/****************************************************************************
 *
 *  *********************************************************************
 *  *   Copyright (C) 2004-2005 KONICA MINOLTA MEDICAL&GAPHIC, INC.     *
 *  *   All rights reserved.                                            *
 *  *********************************************************************
 *
 *Υƥ̾Ρ
 *  DRYPRO MODEL 793 PEBǥХɥ饤
 *
 *Υ⥸塼̾Ρ
 *  PrnDev.c
 *
 *Υȡ
 *  ǥХɥ饤ФΥե
 *
 ****************************************************************************/

#include <linux/config.h>
#if defined(CONFIG_SMP)
#define __SMP__
#endif
#if defined(MODVERSIONS)
#include <linux/modversions.h>
#endif
#if defined(MODULE)
#include <linux/module.h>
#endif
#include <linux/kernel.h>
#include <linux/sched.h>
#include <linux/fs.h>
#include <linux/pci.h>
#include <asm/uaccess.h>

#if defined(MODULE)
MODULE_LICENSE("GPL");
#endif

#include "PebMap.h"
#include "PrnDev.h"


/****************************************************************************
 *
 *
 *  
 *
 *
 ****************************************************************************/

/*==========================================================================*
 *
 *  ǥХ
 *
 *==========================================================================*/
#define PEB_VENDOR_ID   (0x00001587)    // ٥ID
#define PEB_DEVICE_ID   (0x00000805)    // ǥХID

#define DEV_MAJOR_NO    (250)           // ǥХ᥸㡼ֹ

#define DEV_DRIVER_VER  (0x000c)        // ɥ饤ХСֹ(MAJOR)
#define DEV_DRIVER_REV  (0x0000)        // ɥ饤Хӥֹ(MINOR)

#define DMA_PAGE_SIZE   (0x00200000)    // DMAڡ(2MB)


/****************************************************************************
 *
 *
 *  ؿץȥ׾
 *
 *
 ****************************************************************************/

/*==========================================================================*
 *
 *  ⥸塼Ͽؿ
 *
 *==========================================================================*/
static int __init PEB_InitModule(void);
static void __exit PEB_ExitModule(void);

/*==========================================================================*
 *
 *  PCIϿߥϥɥؿ
 *
 *==========================================================================*/
static int __devinit PEB_Probe(struct pci_dev *pPciDev, const struct pci_device_id *pPciDeviceId);
static void __devexit PEB_Remove(struct pci_dev *pPciDev);
static void PEB_Interrupt(int iIrqNo, void *pDevId, struct pt_regs *pRegs);

/*==========================================================================*
 *
 *  եϿؿ
 *
 *==========================================================================*/
static int PEB_Open(struct inode *pNode, struct file *pFile);
static int PEB_Close(struct inode *pNode, struct file *pFile);
static ssize_t PEB_Read(struct file *pFile, char *pcBuffer, size_t uCount, loff_t *pOffset);
static ssize_t PEB_Write(struct file *pFile, const char *pcBuffer, size_t uCount, loff_t *pOffset);
static int PEB_Ioctl(struct inode *pNode, struct file *pFile, unsigned int uCommand, unsigned long ulParameter);

/*==========================================================================*
 *
 *  I/Oȥؿ
 *
 *==========================================================================*/
static int IoctlSetInfo(EIOPSETINFO *pIoParameter);
static int IoctlGetInfo(EIOPGETINFO *pIoParameter);
static int IoctlGetStat(EIOPGETSTAT *pIoParameter);
static int IoctlSetReg(EIOPSETREG *pIoParameter);
static int IoctlGetReg(EIOPGETREG *pIoParameter);
static int IoctlSetMem(EIOPSETMEM *pIoParameter);
static int IoctlGetMem(EIOPGETMEM *pIoParameter);
static int IoctlSetFlash(EIOPSETFLASH *pIoParameter);
static int IoctlGetFlash(EIOPGETFLASH *pIoParameter);
static int IoctlPebTest(EIOPPEBTEST *pIoParameter);
static int IoctlSetExp(EIOPSETEXP *pIoParameter);
static int IoctlGetExp(EIOPGETEXP *pIoParameter);
static int IoctlOpeDma(EIOPOPEDMA *pIoParameter);
static void IrqOpeDma(void);
static int IoctlOpeBrdr(EIOPOPEBRDR *pIoParameter);
static void IrqOpeBrdr(void);
static int IoctlOpeImg(EIOPOPEIMG *pIoParameter);
static void IrqOpeImg(void);
static int IoctlOpeChr(EIOPOPECHR *pIoParameter);
static void IrqOpeChr(void);
static int IoctlOpePtc(EIOPOPEPTC *pIoParameter);
static void IrqOpePtc(void);
static int IoctlOpePrnt(EIOPOPEPRNT *pIoParameter);
static void IrqOpePrnt(void);
static int IoctlPebReset(EIOPPEBRESET *pIoParameter);
static int IoctlDelFlash(EIOPDELFLASH *pIoParameter);

/*==========================================================================*
 *
 *  ؿ
 *
 *==========================================================================*/
static unsigned long PebRegGet(unsigned long ulPebRegAddr, unsigned long ulPebRegMask);
static void PebRegPut(unsigned long ulPebRegAddr, unsigned long ulPebRegMask, unsigned long ulPebRegData);
static void PebRegBitSet(unsigned long ulPebRegAddr, unsigned long ulRegSetBit);
static void PebRegBitClr(unsigned long ulPebRegAddr, unsigned long ulRegClrBit);
static unsigned long PebMemGet(unsigned long ulPebMemAddr);
static void PebMemPut(unsigned long ulPebMemAddr, unsigned long ulPebMemData);
static unsigned char FlashMemGet(unsigned long *pulFlashMemAddr);
static void FlashMemPut(unsigned long *pulFlashMemAddr, unsigned char ucFlashMemData);
static int DataBusTest(void);
static int AddrBusTest(void);
static int MemCompTest(void);
static unsigned int DmaPageRead(unsigned long ulDevBuffAddr, unsigned int uReadSize);
static unsigned int DmaPageWrite(unsigned long ulDevBuffAddr, unsigned int uWriteSize);


/****************************************************************************
 *
 *
 *  Х
 *
 *
 ****************************************************************************/

/*==========================================================================*
 *
 *  ǥХɥ饤о
 *
 *==========================================================================*/
static spinlock_t _uDevSpinLock;        // ǥХ󥿡å

static int _iDevErrorNo;                // ǥХ顼ֹ
static unsigned int _iDevOpeStat;       // ǥХ

static unsigned int _uDevMajorNo;       // chrǥХϿ
static struct pci_driver *_pPciDriver;  // PCIǥХϿ

static unsigned int _uDevDrvVer;        // ǥХɥ饤ФΥСֹ
static unsigned int _uDevDrvRev;        // ǥХɥ饤ФΥӥֹ

/*==========================================================================*
 *
 *  ǥХPCI
 *
 *==========================================================================*/
static struct pci_dev *_pPciDevInfo;    // PCIǥХ
static unsigned long _ulPciBaseAddr0;   // ١ɥ쥹
static unsigned long _ulPciBaseAddr1;   // ١ɥ쥹
static unsigned long _ulPciBaseAddr2;   // ١ɥ쥹
static unsigned long _ulPciIrqLine;     // IRQ饤
static unsigned int _uPciIrqNo;         // IRQֹ

/*==========================================================================*
 *
 *  PEBǥХ
 *
 *==========================================================================*/
static unsigned char *_pucPebRegAddr;   // 쥸ΰ軲ȥݥ
static unsigned char *_pucPebRamAddr;   // ΰ軲ȥݥ
static unsigned char *_pucPebRomAddr;   // FLASHΰ軲ȥݥ

static unsigned int _uPebPrnStat;       // ץȥ顼

static unsigned int _uPebRamType;       // PEB̥

static unsigned int _uPebFpgaVer;       // FPGAǡΥСֹ
static unsigned int _uPebFpgaRev;       // FPGAǡΥӥֹ
static unsigned int _uPebBoardRev;      // PEBĤΥӥֹ

/*==========================================================================*
 *
 *  ǥХI/OХåե
 *
 *==========================================================================*/
static unsigned long *_pulDmaPageBuff;  // DMAڡХåե
static unsigned int _uDmaBuffSize;      // DMAڡХåե

static unsigned char *_pucDevDataBuff;  // ǥХХåե
static unsigned int _uDevBuffSize;      // ǥХХåե
static unsigned int _uDevDataLen;       // ǥХХåեǡ

/*==========================================================================*
 *
 *  PCI-DMA
 *
 *==========================================================================*/
static unsigned long _ulDmaPciBusAddr;  // DMAPCIХɥ쥹
static unsigned long _ulDmaDevBuffAddr; // DMAѥǥХХåեեåȥɥ쥹
static unsigned long _ulDmaPebMemAddr;  // DMAPEB륢ɥ쥹
static unsigned long _ulDmaTotalSize;   // DMAžȡ륵
static unsigned long _ulDmaSentSize;    // DMAžѤߥ
static unsigned long _ulDmaSendSize;    // DMAž


/****************************************************************************
 *
 *
 *  ǥХɥ饤е§ؿ
 *
 *
 ****************************************************************************/

/*==========================================================================*
 *
 *  ⥸塼륨ȥݥ
 *
 *==========================================================================*/
module_init(PEB_InitModule);
module_exit(PEB_ExitModule);

/*==========================================================================*
 *
 *  饯ǥХȥ
 *
 *==========================================================================*/
static struct file_operations _tFileOperations = 
{
    read:       PEB_Read,
    write:      PEB_Write,
    ioctl:      PEB_Ioctl,
    open:       PEB_Open,
    release:    PEB_Close,
};

/*==========================================================================*
 *
 *  PCIǥХȥ
 *
 *==========================================================================*/
static struct pci_device_id _tPciDeviceId[] __initdata = 
{
    { PEB_VENDOR_ID, PEB_DEVICE_ID, PCI_ANY_ID, PCI_ANY_ID, },
    { 0, },
};

#if defined(MODULE)
MODULE_DEVICE_TABLE(pci, _tPciDeviceId);
#endif

static struct pci_driver _tPciDriver = 
{
    name:       PRN_DEV_NAME,
    id_table:   _tPciDeviceId,
    probe:      PEB_Probe,
    remove:     __devexit_p(PEB_Remove),
};

/*==========================================================================*
 *
 *  ǥХɥ饤н
 *
 *==========================================================================*
 *
 *εǽ
 *  ܥ⥸塼ɻ˸ƤФ륹ȥå״ؿ
 *  ܥ⥸塼ɥ饤ФȤϿ롣
 *
 *η
 *  int PEB_InitModule(void);
 *
 *͡
 *  ｪλ    : 0
 *
 *ա
 *
 *==========================================================================*/
static int __init PEB_InitModule(void)
{
    // 
    #ifdef _DEBUG
    printk("%s: PEB_InitModule: IN()\n", PRN_DEV_NAME);
    #endif
    
    printk("%s: Starting PEB_ Print Driver. (V%d.%02dR%02d)\n", PRN_DEV_NAME, 
        (DEV_DRIVER_VER >> 8), (DEV_DRIVER_VER & 0xff), (DEV_DRIVER_REV >> 8));
    
    // ǥХ󥿡åν
    spin_lock_init(&_uDevSpinLock);
    
    // ǥХɥ饤оν
    _iDevErrorNo        = EIOVDEVNOERR;
    _iDevOpeStat        = EIOVDEVUNAVAIL;
    _uDevMajorNo        = 0;
    _pPciDriver         = NULL;
    _uDevDrvVer         = DEV_DRIVER_VER;
    _uDevDrvRev         = DEV_DRIVER_REV;
    
    // ǥХI/OХåեν
    _pucDevDataBuff     = NULL;
    _uDevBuffSize       = 0;
    _uDevDataLen        = 0;
    
    // ɥ饤Ͽ
    if (register_chrdev(DEV_MAJOR_NO, PRN_DEV_NAME, &_tFileOperations) != 0)
    {
        // ϿǤʤ硢ɥ饤Ͽ
        printk("%s: device registration failed.\n", PRN_DEV_NAME);
        _iDevErrorNo = EIOVDEVREGERR;
        goto end;
    }
    _uDevMajorNo = DEV_MAJOR_NO;
    
    // PCIϿ
    if (pci_register_driver(&_tPciDriver) < 1)
    {
        // ϿǤʤ硢ǥХ̤
        printk("%s: device not found.\n", PRN_DEV_NAME);
        _iDevErrorNo = EIOVDEVNOENT;
        goto end;
    }
    _pPciDriver = &_tPciDriver;
    
    // ǥХ֤Ԥ˰ܹ
    _iDevOpeStat = EIOVDEVIDLE;
    
end:
    #ifdef _DEBUG
    printk("%s: _iDevOpeStat = %u\n",   PRN_DEV_NAME, _iDevOpeStat);
    printk("%s: _iDevErrorNo = %d\n",   PRN_DEV_NAME, _iDevErrorNo);
    printk("%s: _uDevDrvVer  = %04X\n", PRN_DEV_NAME, _uDevDrvVer);
    printk("%s: _uDevDrvRev  = %04X\n", PRN_DEV_NAME, _uDevDrvRev);
    #endif
    
    // λ
    #ifdef _DEBUG
    printk("%s: PEB_InitModule: OUT(0)\n", PRN_DEV_NAME);
    #endif
    return (0);
}

/*==========================================================================*
 *
 *  ǥХɥ饤нλ
 *
 *==========================================================================*
 *
 *εǽ
 *  ܥ⥸塼륢ɻ˸ƤФ륯꡼󥢥å״ؿ
 *  ܥɥ饤ФϿ롣
 *
 *η
 *  void PEB_ExitModule(void);
 *
 *͡
 *  ʤ
 *
 *ա
 *
 *==========================================================================*/
static void __exit PEB_ExitModule(void)
{
    // 
    #ifdef _DEBUG
    printk("%s: PEB_ExitModule: IN()\n", PRN_DEV_NAME);
    #endif
    
    printk("%s: Stopping PEB_ Print Driver.\n", PRN_DEV_NAME);
    
    // PCIϿβ
    if (_pPciDriver != NULL)
    {
        pci_unregister_driver(_pPciDriver);
        _pPciDriver = NULL;
    }
    
    // ɥ饤Ͽβ
    if (_uDevMajorNo != 0)
    {
        unregister_chrdev(_uDevMajorNo, PRN_DEV_NAME);
        _uDevMajorNo = 0;
    }
    
    // ǥХХåե˴
    if (_pucDevDataBuff)
    {
        vfree(_pucDevDataBuff);
        _pucDevDataBuff = NULL;
        _uDevBuffSize   = 0;
        _uDevDataLen    = 0;
    }
    
    // λ
    #ifdef _DEBUG
    printk("%s: PEB_ExitModule: OUT()\n", PRN_DEV_NAME);
    #endif
    return;
}


/****************************************************************************
 *
 *
 *  PCIϿߥϥɥؿ
 *
 *
 ****************************************************************************/

/*==========================================================================*
 *
 *  PCI
 *
 *==========================================================================*
 *
 *εǽ
 *  PCI˸ƤФؿ
 *  ܥɥ饤Ф꥽롣
 *
 *η
 *  int PEB_Probe(
 *      struct pci_dev *pPciDev,                    // [I] PCIǥХ󻲾ȥݥ
 *      const struct pci_device_id *pPciDeviceId    // [I] PCIǥХID󻲾ȥݥ
 *  );
 *
 *͡
 *  ｪλ    : 0
 *
 *ա
 *
 *==========================================================================*/
static int __devinit PEB_Probe(struct pci_dev *pPciDev, const struct pci_device_id *pPciDeviceId)
{
    // 
    #ifdef _DEBUG
    printk("%s: PEB_Probe: IN(%p,%p)\n", PRN_DEV_NAME, pPciDev, pPciDeviceId);
    #endif
    
    // ǥХPCIν
    _pPciDevInfo        = pPciDev;
    _ulPciBaseAddr0     = 0x0;
    _ulPciBaseAddr1     = 0x0;
    _ulPciBaseAddr2     = 0x0;
    _ulPciIrqLine       = 0x0;
    _uPciIrqNo          = 0;
    
    // PEBǥХν
    _pucPebRegAddr      = NULL;
    _pucPebRamAddr      = NULL;
    _pucPebRomAddr      = NULL;
    _uPebPrnStat        = 0;
    _uPebRamType        = 0;
    _uPebFpgaVer        = 0;
    _uPebFpgaRev        = 0;
    _uPebBoardRev       = 0;
    
    // ǥХI/OХåեν
    _pulDmaPageBuff     = NULL;
    _uDmaBuffSize       = DMA_PAGE_SIZE;
    
    // PCI-DMAν
    _ulDmaPciBusAddr    = 0;
    _ulDmaPebMemAddr    = 0;
    _ulDmaDevBuffAddr   = 0;
    _ulDmaTotalSize     = 0;
    _ulDmaSentSize      = 0;
    _ulDmaSendSize      = 0;
    
    // PCI֥͡
    pci_enable_device(_pPciDevInfo);
    
    // ФǥХ١ɥ쥹μ
    _ulPciBaseAddr0 = pci_resource_start(_pPciDevInfo, 0);
    _ulPciBaseAddr1 = pci_resource_start(_pPciDevInfo, 1);
    _ulPciBaseAddr2 = pci_resource_start(_pPciDevInfo, 2);
    
    // ФǥХIRQ饤μ
    _ulPciIrqLine = (unsigned long)_pPciDevInfo->irq;
    
    // ١ɥ쥹쥸ΰγ
    _pucPebRegAddr = ioremap(_ulPciBaseAddr0, pci_resource_len(_pPciDevInfo, 0));
    if (!_pucPebRegAddr)
    {
        // Ǥʤ硢I/Oޥåԥ󥰼
        printk("%s: I/O mapping failed.\n", PRN_DEV_NAME);
        _iDevErrorNo = EIOVDEVIOMERR;
        goto end;
    }
    
    // ١ɥ쥹ΰγ
    _pucPebRamAddr = ioremap(_ulPciBaseAddr1, pci_resource_len(_pPciDevInfo, 1));
    if (!_pucPebRamAddr)
    {
        // Ǥʤ硢I/Oޥåԥ󥰼
        printk("%s: I/O mapping failed.\n", PRN_DEV_NAME);
        _iDevErrorNo = EIOVDEVIOMERR;
        goto end;
    }
    
    // ١ɥ쥹FLASHΰγ
    _pucPebRomAddr = ioremap(_ulPciBaseAddr2, pci_resource_len(_pPciDevInfo, 2));
    if (!_pucPebRomAddr)
    {
        // Ǥʤ硢I/Oޥåԥ󥰼
        printk("%s: I/O mapping failed.\n", PRN_DEV_NAME);
        _iDevErrorNo = EIOVDEVIOMERR;
        goto end;
    }
    
    // DMAڡХåեγ
    _pulDmaPageBuff = (unsigned long *)__get_dma_pages(GFP_KERNEL, get_order(_uDmaBuffSize));
    if (!_pulDmaPageBuff)
    {
        // Ǥʤ硢ʪ
        printk("%s: physical memory allocation failed.\n", PRN_DEV_NAME);
        _iDevErrorNo = EIOVDEVPHYERR;
        goto end;
    }
    
    // DMAPCIХɥ쥹λ
    _ulDmaPciBusAddr = virt_to_bus(_pulDmaPageBuff);
    
    // IRQϥɥϿ
    if (request_irq((unsigned int)_ulPciIrqLine, PEB_Interrupt, SA_INTERRUPT | SA_SHIRQ, PRN_DEV_NAME, _pPciDevInfo) != 0)
    {
        // ϿǤʤ硢IRQϿ
        printk("%s: IRQ registration failed.\n", PRN_DEV_NAME);
        _iDevErrorNo = EIOVDEVIRQERR;
        goto end;
    }
    _uPciIrqNo = (unsigned int)_ulPciIrqLine;
    
    // ץȥ̥쥸PEB̥פμ
    _uPebRamType = PebRegGet(REG_Prt_Mem, MSK_Prt_Mem);
    
    // FPGAС쥸FPGAǡΥС󡿥ӥֹμ
    _uPebFpgaVer = _uPebFpgaRev = PebRegGet(REG_FPGA_Ver, MSK_FPGA_Ver);
    _uPebFpgaVer = (_uPebFpgaVer & BIT_FVER) >> 4;
    _uPebFpgaRev = _uPebFpgaRev & BIT_FREV;
    
    // PEBӥ쥸PEBĤΥӥֹμ
    _uPebBoardRev = PebRegGet(REG_PEB_Rev, MSK_PEB_Rev);
    _uPebBoardRev = _uPebBoardRev & BIT_PREV;
    
end:
    #ifdef _DEBUG
    printk("%s: _pPciDevInfo     = %p\n",    PRN_DEV_NAME, _pPciDevInfo);
    printk("%s: _ulPciBaseAddr0  = %08lX\n", PRN_DEV_NAME, _ulPciBaseAddr0);
    printk("%s: _ulPciBaseAddr1  = %08lX\n", PRN_DEV_NAME, _ulPciBaseAddr1);
    printk("%s: _ulPciBaseAddr2  = %08lX\n", PRN_DEV_NAME, _ulPciBaseAddr2);
    printk("%s: _uPciIrqNo       = %u\n",    PRN_DEV_NAME, _uPciIrqNo);
    printk("%s: _pucPebRegAddr   = %p\n",    PRN_DEV_NAME, _pucPebRegAddr);
    printk("%s: _pucPebRamAddr   = %p\n",    PRN_DEV_NAME, _pucPebRamAddr);
    printk("%s: _pucPebRomAddr   = %p\n",    PRN_DEV_NAME, _pucPebRomAddr);
    printk("%s: _uPebRamType     = %u\n",    PRN_DEV_NAME, _uPebRamType);
    printk("%s: _uPebFpgaVer     = %04X\n",  PRN_DEV_NAME, _uPebFpgaVer);
    printk("%s: _uPebFpgaRev     = %04X\n",  PRN_DEV_NAME, _uPebFpgaRev);
    printk("%s: _uPebBoardRev    = %04X\n",  PRN_DEV_NAME, _uPebBoardRev);
    printk("%s: _uDmaBuffSize    = %u\n",    PRN_DEV_NAME, _uDmaBuffSize);
    printk("%s: _pulDmaPageBuff  = %p\n",    PRN_DEV_NAME, _pulDmaPageBuff);
    printk("%s: _ulDmaPciBusAddr = %08lX\n", PRN_DEV_NAME, _ulDmaPciBusAddr);
    #endif
    
    // λ
    #ifdef _DEBUG
    printk("%s: PEB_Probe: OUT(0)\n", PRN_DEV_NAME);
    #endif
    return (0);
}

/*==========================================================================*
 *
 *  PCIλ
 *
 *==========================================================================*
 *
 *εǽ
 *  PCIλ˸ƤФ뽪λؿ
 *  ܥɥ饤Фä꥽롣
 *
 *η
 *  void PEB_Remove(void);
 *
 *͡
 *  ʤ
 *
 *ա
 *
 *==========================================================================*/
static void __devexit PEB_Remove(struct pci_dev *pPciDev)
{
    // 
    #ifdef _DEBUG
    printk("%s: PEB_Remove: IN(%p)\n", PRN_DEV_NAME, pPciDev);
    #endif
    
    // IRQϥɥκ
    if (_uPciIrqNo != 0)
    {
        free_irq(_uPciIrqNo, _pPciDevInfo);
        _uPciIrqNo = 0;
    }
    
    // DMAڡХåե˴
    if (_pulDmaPageBuff)
    {
        free_page((unsigned long)_pulDmaPageBuff);
        _pulDmaPageBuff = NULL;
        _uDmaBuffSize   = 0;
    }
    
    // FLASHΰβ
    if (_pucPebRomAddr)
    {
        iounmap(_pucPebRomAddr);
        _pucPebRomAddr = NULL;
    }
    
    // ΰβ
    if (_pucPebRamAddr)
    {
        iounmap(_pucPebRamAddr);
        _pucPebRamAddr = NULL;
    }
    
    // 쥸ΰβ
    if (_pucPebRegAddr)
    {
        iounmap(_pucPebRegAddr);
        _pucPebRegAddr = NULL;
    }
    
    // λ
    #ifdef _DEBUG
    printk("%s: PEB_Remove: OUT()\n", PRN_DEV_NAME);
    #endif
    return;
}

/*==========================================================================*
 *
 *  IRQߥϥɥ
 *
 *==========================================================================*
 *
 *εǽ
 *  IRQߤȯ˸ƤФϥɥؿ
 *  װϤܥɥ饤Ф߾򹹿롣
 *  ޤȯߤΥꥻåȤ碌ƹԤ
 *
 *η
 *  void PEB_Interrupt(
 *      int iIrqNo,             // [I] IRQֹ
 *      void *pDevId,           // [I] ǥХ̾󻲾ȥݥ
 *      struct pt_regs *pRegs   // [I] CPUƥȾ󻲾ȥݥ
 *  );
 *
 *͡
 *  ʤ
 *
 *ա
 *
 *==========================================================================*/
static void PEB_Interrupt(int iIrqNo, void *pDevId, struct pt_regs *pRegs)
{
    unsigned long ulIntReq;
    
    // 
    #ifdef _DEBUG
    printk("%s: PEB_Interrupt: IN(%d,%p,%p)\n", PRN_DEV_NAME, iIrqNo, pDevId, pRegs);
    #endif
    
    // ǥХIDΥå
    if (pDevId != _pPciDevInfo)
        goto end;
    
    // INTAװ쥸Υ꡼
    if ((ulIntReq = PebRegGet(REG_Int_Req, MSK_Int_Req)) == 0)
        goto end;
    
    // INTAޥ쥸å
    PebRegPut(REG_Int_Msk, MSK_Int_Msk, ~0);
    
    // INTAװ쥸ꥢ
    PebRegPut(REG_Int_Req, MSK_Int_Req, 0);
    
    // INTAװ쥸ͤPCI-DMAžλߤξ硢DMA߽
    if (ulIntReq & BIT_PDMAINT)
        IrqOpeDma();
    
    // INTAװ쥸ͤܡλߤξ硢ܡ߽
    if (ulIntReq & BIT_BRDRINT)
        IrqOpeBrdr();
    
    // INTAװ쥸ͤλߤξ硢߽
    if (ulIntReq & BIT_IMGINT)
        IrqOpeImg();
    
    // INTAװ쥸ͤʸλߤξ硢ʸ߽
    if (ulIntReq & BIT_CHRINT)
        IrqOpeChr();
    
    // INTAװ쥸ͤǻ٥ѥåλߤξ硢ǻ٥ѥå߽
    if (ulIntReq & BIT_PTCINT)
        IrqOpePtc();
    
    // INTAװ쥸ͤץȽλߤξ硢ץȳ߽
    if (ulIntReq & BIT_PRNTINT)
        IrqOpePrnt();
    
end:
    // λ
    #ifdef _DEBUG
    printk("%s: PEB_Interrupt: OUT()\n", PRN_DEV_NAME);
    #endif
    return;
}


/****************************************************************************
 *
 *
 *  եϿؿ
 *
 *
 ****************************************************************************/

/*==========================================================================*
 *
 *  ץ᥽åɽ
 *
 *==========================================================================*
 *
 *εǽ
 *  open()ƥॳƤФ᥽åɴؿ
 *  ܥɥ饤ФǥХ򹹿롣
 *
 *η
 *  int PEB_Open(
 *      struct inode *pNode,    // [I] Ρɾ󻲾ȥݥ
 *      struct file *pFile      // [I] ե󻲾ȥݥ
 *  );
 *
 *͡
 *  ｪλ    : 0
 *
 *ա
 *
 *==========================================================================*/
static int PEB_Open(struct inode *pNode, struct file *pFile)
{
    int iResult = 0;
    
    // 
    #ifdef _DEBUG
    printk("%s: PEB_Open: IN(%p,%p)\n", PRN_DEV_NAME, pNode, pFile);
    #endif
    
    // ǥХץΥȥå
#if defined(MODULE)
    MOD_INC_USE_COUNT;
#endif
    
    // λ
    #ifdef _DEBUG
    printk("%s: PEB_Open: OUT(%d)\n", PRN_DEV_NAME, iResult);
    #endif
    return (iResult);
}

/*==========================================================================*
 *
 *  ᥽åɽ
 *
 *==========================================================================*
 *
 *εǽ
 *  close()ƥॳƤФ᥽åɴؿ
 *  ܥɥ饤ФǥХ򹹿롣
 *
 *η
 *  int PEB_Close(
 *      struct inode *pNode,    // [I] Ρɾ󻲾ȥݥ
 *      struct file *pFile      // [I] ե󻲾ȥݥ
 *  );
 *
 *͡
 *  ｪλ    : 0
 *
 *ա
 *
 *==========================================================================*/
static int PEB_Close(struct inode *pNode, struct file *pFile)
{
    int iResult = 0;
    
    // 
    #ifdef _DEBUG
    printk("%s: PEB_Close: IN(%p,%p)\n", PRN_DEV_NAME, pNode, pFile);
    #endif
    
    // ǥХץΥȥ
#if defined(MODULE)
    MOD_DEC_USE_COUNT;
#endif
    
    // λ
    #ifdef _DEBUG
    printk("%s: PEB_Close: OUT(%d)\n", PRN_DEV_NAME, iResult);
    #endif
    return (iResult);
}

/*==========================================================================*
 *
 *  ꡼ɥ᥽åɽ
 *
 *==========================================================================*
 *
 *εǽ
 *  read()ƥॳƤФ᥽åɴؿ
 *  ܥɥ饤ФǥХХåե˳ǼƤǡ
 *  ꥵʬɤ߹ߥǡǼХåե˳Ǽ롣
 *
 *η
 *  ssize_t PEB_Read(
 *      struct file *pFile, // [I] ե󻲾ȥݥ
 *      char *pcBuffer,     // [O] ɤ߹ߥǡǼХåե
 *      size_t uCount,      // [I] ɤ߹ߥǡ
 *      loff_t *pOffset     // [I] եåȾ󻲾ȥݥ
 *  );
 *
 *͡
 *  ¥ǡ      : 0ʾ
 *  ꥽  : -EBUSY
 *
 *ա
 *  ԥå
 *  ǥХ֤Ԥʳξϥӥ
 *
 *==========================================================================*/
static ssize_t PEB_Read(struct file *pFile, char *pcBuffer, size_t uCount, loff_t *pOffset)
{
    ssize_t uReadCount = -EBUSY;
    
    // 
    #ifdef _DEBUG
    printk("%s: PEB_Read: IN(%p,%p,%u,%p)\n", PRN_DEV_NAME, pFile, pcBuffer, uCount, pOffset);
    #endif
    
    // ǥХå
    spin_lock(&_uDevSpinLock);
    
    // ǥХ֤Ԥʳξϥ꥽
    if (_iDevOpeStat != EIOVDEVIDLE)
        goto end;
    
    // ¥ǡλ
    uReadCount = (uCount < _uDevDataLen)? uCount: _uDevDataLen;
    
    // ¥ǡʬǥХХåեǼǡɤ߹ߥǡǼХåե˳Ǽ
    if (uReadCount > 0)
        uReadCount -= copy_to_user(pcBuffer, _pucDevDataBuff, uReadCount);
    
end:
    // ǥХåβ
    spin_unlock(&_uDevSpinLock);
    
    // λ
    #ifdef _DEBUG
    printk("%s: PEB_Read: OUT(%d)\n", PRN_DEV_NAME, uReadCount);
    #endif
    return (uReadCount);
}

/*==========================================================================*
 *
 *  饤ȥ᥽åɽ
 *
 *==========================================================================*
 *
 *εǽ
 *  write()ƥॳƤФ᥽åɴؿ
 *  񤭹ߥǡǼХåե˳ǼƤǡ
 *  ꥵܥɥ饤ФǥХХåե˳Ǽ롣
 *
 *η
 *  ssize_t PEB_Write(
 *      struct file *pFile,     // [I] ե󻲾ȥݥ
 *      const char *pcBuffer,   // [I] 񤭹ߥǡǼХåե
 *      size_t uCount,          // [I] 񤭹ߥǡ
 *      loff_t *pOffset         // [I] եåȾ󻲾ȥݥ
 *  );
 *
 *͡
 *  ¥ǡ      : 0ʾ
 *  ꥽  : -EBUSY
 *
 *ա
 *  ԥå
 *  ǥХ֤Ԥʳξϥӥ
 *
 *==========================================================================*/
static ssize_t PEB_Write(struct file *pFile, const char *pcBuffer, size_t uCount, loff_t *pOffset)
{
    ssize_t uWriteCount = -EBUSY;
    
    // 
    #ifdef _DEBUG
    printk("%s: PEB_Write: IN(%p,%p,%u,%p)\n", PRN_DEV_NAME, pFile, pcBuffer, uCount, pOffset);
    #endif
    
    // ǥХå
    spin_lock(&_uDevSpinLock);
    
    // ǥХ֤Ԥʳξϥ꥽
    if (_iDevOpeStat != EIOVDEVIDLE)
        goto end;
    
    // ¥ǡλ
    uWriteCount = (uCount < _uDevBuffSize)? uCount: _uDevBuffSize;
    
    // ¥ǡʬ񤭹ߥǡǼХåեǼǡǥХХåե˳Ǽ
    if (uWriteCount > 0)
        uWriteCount -= copy_from_user(_pucDevDataBuff, pcBuffer, uWriteCount);
    
    // ǥХХåեǡι
    _uDevDataLen = uWriteCount;
    
end:
    // ǥХåβ
    spin_unlock(&_uDevSpinLock);
    
    // λ
    #ifdef _DEBUG
    printk("%s: PEB_Write: OUT(%d)\n", PRN_DEV_NAME, uWriteCount);
    #endif
    return (uWriteCount);
}

/*==========================================================================*
 *
 *  I/Oȥ᥽åɽ
 *
 *==========================================================================*
 *
 *εǽ
 *  ioctl()ƥॳƤФ᥽åɴؿ
 *  ꤵ줿ޥɤ˽äơ򿶤ʬ롣
 *
 *η
 *  int PEB_Ioctl(
 *      struct inode *pNode,        // [I] Ρɾ󻲾ȥݥ
 *      struct file *pFile,         // [I] ե󻲾ȥݥ
 *      unsigned int uCommand,      // [I] I/Oޥ
 *      unsigned long ulParameter   // [I] I/Oѥ᡼
 *  );
 *
 *͡
 *  ｪλ        : 0
 *  ޥ    : -EINVAL
 *  ɥ쥹    : -EFAULT
 *
 *ա
 *  ԥå
 *
 *==========================================================================*/
static int PEB_Ioctl(struct inode *pNode, struct file *pFile, unsigned int uCommand, unsigned long ulParameter)
{
    int iResult = -EINVAL;
    static union {
        EIOPSETINFO  iopSetInfo;    // ǥХ
        EIOPGETINFO  iopGetInfo;    // ǥХ
        EIOPGETSTAT  iopGetStat;    // ǥХּ
        EIOPSETREG   iopSetReg;     // PEB쥸
        EIOPGETREG   iopGetReg;     // PEB쥸
        EIOPSETMEM   iopSetMem;     // PEB
        EIOPGETMEM   iopGetMem;     // PEB
        EIOPSETFLASH iopSetFlash;   // FLASH
        EIOPGETFLASH iopGetFlash;   // FLASH
        EIOPPEBTEST  iopPebTest;    // PEBƥ
        EIOPSETEXP   iopSetExp;     // Ϫ
        EIOPGETEXP   iopGetExp;     // Ϫּ
        EIOPOPEDMA   iopOpeDma;     // DMA
        EIOPOPEBRDR  iopOpeBrdr;    // ܡ
        EIOPOPEIMG   iopOpeImg;     // 
        EIOPOPECHR   iopOpeChr;     // ʸ
        EIOPOPEPTC   iopOpePtc;     // ǻ٥ѥå
        EIOPOPEPRNT  iopOpePrnt;    // ץȽ
        EIOPPEBRESET iopPebReset;   // PEBꥻå
        EIOPDELFLASH iopDelFlash;   // FLASHõ
    } IoParameters;
    static struct {
        unsigned int uCommand;
        unsigned int uSize;
        int (*pFunction)(void *pIoParameter);
    } IoctlEntList[EIOCMAXNO] = {
        { EIOCSETINFO,  sizeof(EIOPSETINFO),    (int (*)(void *))IoctlSetInfo,  },  // ǥХ
        { EIOCGETINFO,  sizeof(EIOPGETINFO),    (int (*)(void *))IoctlGetInfo,  },  // ǥХ
        { EIOCGETSTAT,  sizeof(EIOPGETSTAT),    (int (*)(void *))IoctlGetStat,  },  // ǥХּ
        { EIOCSETREG,   sizeof(EIOPSETREG),     (int (*)(void *))IoctlSetReg,   },  // PEB쥸
        { EIOCGETREG,   sizeof(EIOPGETREG),     (int (*)(void *))IoctlGetReg,   },  // PEB쥸
        { EIOCSETMEM,   sizeof(EIOPSETMEM),     (int (*)(void *))IoctlSetMem,   },  // PEB
        { EIOCGETMEM,   sizeof(EIOPGETMEM),     (int (*)(void *))IoctlGetMem,   },  // PEB
        { EIOCSETFLASH, sizeof(EIOPSETFLASH),   (int (*)(void *))IoctlSetFlash, },  // FLASH
        { EIOCGETFLASH, sizeof(EIOPGETFLASH),   (int (*)(void *))IoctlGetFlash, },  // FLASH
        { EIOCPEBTEST,  sizeof(EIOPPEBTEST),    (int (*)(void *))IoctlPebTest,  },  // PEBƥ
        { EIOCSETEXP,   sizeof(EIOPSETEXP),     (int (*)(void *))IoctlSetExp,   },  // Ϫ
        { EIOCGETEXP,   sizeof(EIOPGETEXP),     (int (*)(void *))IoctlGetExp,   },  // Ϫּ
        { EIOCOPEDMA,   sizeof(EIOPOPEDMA),     (int (*)(void *))IoctlOpeDma,   },  // DMA
        { EIOCOPEBRDR,  sizeof(EIOPOPEBRDR),    (int (*)(void *))IoctlOpeBrdr,  },  // ܡ
        { EIOCOPEIMG,   sizeof(EIOPOPEIMG),     (int (*)(void *))IoctlOpeImg,   },  // 
        { EIOCOPECHR,   sizeof(EIOPOPECHR),     (int (*)(void *))IoctlOpeChr,   },  // ʸ
        { EIOCOPEPTC,   sizeof(EIOPOPEPTC),     (int (*)(void *))IoctlOpePtc,   },  // ǻ٥ѥå
        { EIOCOPEPRNT,  sizeof(EIOPOPEPRNT),    (int (*)(void *))IoctlOpePrnt,  },  // ץȽ
        { EIOCPEBRESET, sizeof(EIOPPEBRESET),   (int (*)(void *))IoctlPebReset, },  // PEBꥻå
        { EIOCDELFLASH, sizeof(EIOPDELFLASH),   (int (*)(void *))IoctlDelFlash, },  // FLASHõ
    };
    int iPoint;
    
    // 
    #ifdef _DEBUG
    printk("%s: PEB_Ioctl: IN(%p,%p,%X,%08lX)\n", PRN_DEV_NAME, pNode, pFile, uCommand, ulParameter);
    #endif
    
    // ǥХå
    spin_lock(&_uDevSpinLock);
    
    // I/OȥϿꥹȤ򸡺
    for (iPoint = 0; iPoint < EIOCMAXNO; iPoint ++)
    {
        // I/OޥɤΥå
        if (uCommand != IoctlEntList[iPoint].uCommand)
            continue;
        
        // ޥɥѥ᡼
        if (IoctlEntList[iPoint].uSize > 0)
        {
            // 桼ѥ᡼ΰå
            if (!access_ok(VERIFY_WRITE, (void *)ulParameter, IoctlEntList[iPoint].uSize))
            {
                // ɥ쥹
                iResult = -EFAULT;
                break;
            }
        }
        
        // I/Oѥ᡼򸵤ˡ׵ѥ᡼μ
        copy_from_user(&IoParameters, (void *)ulParameter, IoctlEntList[iPoint].uSize);
        
        // I/Oե󥯥󥳡
        iResult = (*IoctlEntList[iPoint].pFunction)(&IoParameters);
        
        // I/Oѥ᡼򸵤ˡѥ᡼γǼ
        copy_to_user((void *)ulParameter, &IoParameters, IoctlEntList[iPoint].uSize);
        
        // λ
        break;
    }
    
    // ǥХåβ
    spin_unlock(&_uDevSpinLock);
    
    // λ
    #ifdef _DEBUG
    printk("%s: PEB_Ioctl: OUT(%d)\n", PRN_DEV_NAME, iResult);
    #endif
    return (iResult);
}


/****************************************************************************
 *
 *
 *  I/Oȥؿ
 *
 *
 ****************************************************************************/

/*==========================================================================*
 *
 *  ǥХ
 *
 *==========================================================================*
 *
 *εǽ
 *  I/Oȥ᥽åɤƤФؿ
 *  I/Oѥ᡼򸵤˥ǥХꤹ롣
 *
 *η
 *  int IoctlSetInfo(
 *      EIOPSETINFO *pIoParameter   // [I] I/Oѥ᡼
 *  );
 *
 *͡
 *  ｪλ        : 0
 *  ꥽  : -EBUSY
 *
 *ա
 *  ǥХ֤Ԥʳξϥӥ
 *
 *==========================================================================*/
static int IoctlSetInfo(EIOPSETINFO *pIoParameter)
{
    int iResult = -EBUSY;
    
    // 
    #ifdef _DEBUG
    printk("%s: IoctlSetInfo: IN(%p)\n", PRN_DEV_NAME, pIoParameter);
    #endif
    
    // ǥХ֤Ԥʳξϥ꥽
    if (_iDevOpeStat != EIOVDEVIDLE)
        goto end;
    
    #ifdef _DEBUG
    printk("%s: pIoParameter->ulDevBuffSize = %lu\n", PRN_DEV_NAME, pIoParameter->ulDevBuffSize);
    #endif
    
    // ѥ᡼ꤵ줿ǥХХåե򸵤˥ǥХХåեι
    _uDevBuffSize = (pIoParameter->ulDevBuffSize + (_uDmaBuffSize - 1)) / _uDmaBuffSize * _uDmaBuffSize;
    
    // ǥХХåեγå
    if (_pucDevDataBuff)
    {
        // ä
        vfree(_pucDevDataBuff);
        _pucDevDataBuff = NULL;
        _uDevDataLen = 0;
    }
    
    // ǥХХåեκƳ
    _pucDevDataBuff = vmalloc(_uDevBuffSize);
    if (!_pucDevDataBuff)
    {
        // ǥХХåե
        printk("%s: kernel memory allocation failed.\n", PRN_DEV_NAME);
        _iDevErrorNo = EIOVDEVMEMERR;
        _uDevBuffSize = 0;
    }
    
    // ｪλ
    iResult = 0;
    
end:
    // λ
    #ifdef _DEBUG
    printk("%s: IoctlSetInfo: OUT(%d)\n", PRN_DEV_NAME, iResult);
    #endif
    return (iResult);
}

/*==========================================================================*
 *
 *  ǥХ
 *
 *==========================================================================*
 *
 *εǽ
 *  I/Oȥ᥽åɤƤФؿ
 *  I/Oѥ᡼򸵤˥ǥХ롣
 *
 *η
 *  int IoctlGetInfo(
 *      EIOPGETINFO *pIoParameter   // [I] I/Oѥ᡼
 *  );
 *
 *͡
 *  ｪλ        : 0
 *  ꥽  : -EBUSY
 *
 *ա
 *
 *==========================================================================*/
static int IoctlGetInfo(EIOPGETINFO *pIoParameter)
{
    int iResult = -EBUSY;
    
    // 
    #ifdef _DEBUG
    printk("%s: IoctlGetInfo: IN(%p)\n", PRN_DEV_NAME, pIoParameter);
    #endif
    
    // ǥХХåեγǼ
    pIoParameter->ulDevBuffSize = _uDevBuffSize;
    
    // ǥХǡĹγǼ
    pIoParameter->ulDevDataLen = _uDevDataLen;
    
    // PEB̥פγǼ
    pIoParameter->ulPebRamType = _uPebRamType;
    
    // եȳǼɥ쥹γǼ
    pIoParameter->ulPebFontAddr = RAM_Font_Adr;
    
    // ϲǼɥ쥹γǼ
    pIoParameter->ulPebImgInAddr[0] = RAM_Img_InAdr_512;
    pIoParameter->ulPebImgInAddr[1] = RAM_Img_InAdr_1024;
    
    // ֲǼɥ쥹γǼ
    pIoParameter->ulPebImgTmpAddr[0] = RAM_Img_TmpAdr_512;
    pIoParameter->ulPebImgTmpAddr[1] = RAM_Img_TmpAdr_1024;
    
    // ϲǼɥ쥹γǼ
    pIoParameter->ulPebImgOutAddr[0] = RAM_Img_OutAdr_512;
    pIoParameter->ulPebImgOutAddr[1] = RAM_Img_OutAdr_1024;
    
    // 쥸ΰ襵γǼ
    pIoParameter->ulPebRegSize = REG_PCI_SIZE;
    
    // 쥸ΰ襢ɥ쥹γǼ
    pIoParameter->ulPebRegAddr = PEB_REG_ADDR;
    
    // ɥ饤ХСֹγǼ
    pIoParameter->ulDevDrvVer = _uDevDrvVer;
    
    // ɥ饤ХӥֹγǼ
    pIoParameter->ulDevDrvRev = _uDevDrvRev;
    
    // FPGAǡСֹγǼ
    pIoParameter->ulPebFpgaVer = _uPebFpgaVer;
    
    // FPGAǡӥֹγǼ
    pIoParameter->ulPebFpgaRev = _uPebFpgaRev;
    
    // PEBĥӥֹγǼ
    pIoParameter->ulPebBoardRev = _uPebBoardRev;
    
    // FPGAե졼ΰ襵γǼ
    pIoParameter->ulPebRomSize = ROM_FPGA_Data2 - ROM_FPGA_Data1;
    
    // FPGAե졼ΰ襢ɥ쥹γǼ
    pIoParameter->ulPebRomAddr[0] = ROM_FPGA_Data1;
    pIoParameter->ulPebRomAddr[1] = ROM_FPGA_Data2;
    
    #ifdef _DEBUG
    printk("%s: pIoParameter->ulDevBuffSize      = %lu\n",   PRN_DEV_NAME, pIoParameter->ulDevBuffSize);
    printk("%s: pIoParameter->ulDevDataLen       = %lu\n",   PRN_DEV_NAME, pIoParameter->ulDevDataLen);
    printk("%s: pIoParameter->ulPebRamType       = %lu\n",   PRN_DEV_NAME, pIoParameter->ulPebRamType);
    printk("%s: pIoParameter->ulPebFontAddr      = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPebFontAddr);
    printk("%s: pIoParameter->ulPebImgInAddr[0]  = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPebImgInAddr[0]);
    printk("%s: pIoParameter->ulPebImgInAddr[1]  = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPebImgInAddr[1]);
    printk("%s: pIoParameter->ulPebImgTmpAddr[0] = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPebImgTmpAddr[0]);
    printk("%s: pIoParameter->ulPebImgTmpAddr[1] = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPebImgTmpAddr[1]);
    printk("%s: pIoParameter->ulPebImgOutAddr[0] = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPebImgOutAddr[0]);
    printk("%s: pIoParameter->ulPebImgOutAddr[1] = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPebImgOutAddr[1]);
    printk("%s: pIoParameter->ulPebRegSize       = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPebRegSize);
    printk("%s: pIoParameter->ulPebRegAddr       = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPebRegAddr);
    printk("%s: pIoParameter->ulDevDrvVer        = %08lX\n", PRN_DEV_NAME, pIoParameter->ulDevDrvVer);
    printk("%s: pIoParameter->ulDevDrvRev        = %08lX\n", PRN_DEV_NAME, pIoParameter->ulDevDrvRev);
    printk("%s: pIoParameter->ulPebFpgaVer       = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPebFpgaVer);
    printk("%s: pIoParameter->ulPebFpgaRev       = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPebFpgaRev);
    printk("%s: pIoParameter->ulPebBoardRev      = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPebBoardRev);
    printk("%s: pIoParameter->ulPebRomSize       = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPebRomSize);
    printk("%s: pIoParameter->ulPebRomAddr[0]    = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPebRomAddr[0]);
    printk("%s: pIoParameter->ulPebRomAddr[1]    = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPebRomAddr[1]);
    #endif
    
    // ｪλ
    iResult = 0;
    
    // λ
    #ifdef _DEBUG
    printk("%s: IoctlGetInfo: OUT(%d)\n", PRN_DEV_NAME, iResult);
    #endif
    return (iResult);
}

/*==========================================================================*
 *
 *  ǥХּ
 *
 *==========================================================================*
 *
 *εǽ
 *  I/Oȥ᥽åɤƤФؿ
 *  I/Oѥ᡼򸵤˥ǥХ֤롣
 *
 *η
 *  int IoctlGetStat(
 *      EIOPGETSTAT *pIoParameter   // [I] I/Oѥ᡼
 *  );
 *
 *͡
 *  ｪλ        : 0
 *  ꥽  : -EBUSY
 *
 *ա
 *
 *==========================================================================*/
static int IoctlGetStat(EIOPGETSTAT *pIoParameter)
{
    int iResult = -EBUSY;
    
    // 
    #ifdef _DEBUG
    printk("%s: IoctlGetStat: IN(%p)\n", PRN_DEV_NAME, pIoParameter);
    #endif
    
    // ǥХ顼ֹγǼ
    pIoParameter->ulDevErrorNo = (unsigned long)_iDevErrorNo;
    
    // ǥХ֤γǼ
    pIoParameter->ulDevOpeStat = (unsigned long)_iDevOpeStat;
    
    // ץȥơ쥸ͤγǼ
    if (_iDevOpeStat != EIOVDEVUNAVAIL)
        pIoParameter->ulPrtState = PebRegGet(REG_Prt_State, MSK_Prt_State);
    else
        pIoParameter->ulPrtState = 0;
    
    // ץȥơ쥸ͤPRST򸵤PEB֤γǼ
    pIoParameter->ulPebOpeStat = pIoParameter->ulPrtState & BIT_PRST;
    
    // ץȽ֤γǼ
    if (_iDevOpeStat != EIOVDEVUNAVAIL)
        pIoParameter->ulPebPrnStat = _uPebPrnStat;
    else
        pIoParameter->ulPebPrnStat = 0;
    
    // PCI-DMA쥸ͤγǼ
    if (_iDevOpeStat != EIOVDEVUNAVAIL)
        pIoParameter->ulPDMACtl = PebRegGet(REG_PDMA_Ctl, MSK_PDMA_Ctl);
    else
        pIoParameter->ulPDMACtl = 0;
    
    // ˥å쥸ͤγǼ
    if (_iDevOpeStat != EIOVDEVUNAVAIL)
        pIoParameter->ulUnitCtl = PebRegGet(REG_Unit_Ctl, MSK_Unit_Ctl);
    else
        pIoParameter->ulUnitCtl = 0;
    
    // ץ쥸ͤγǼ
    if (_iDevOpeStat != EIOVDEVUNAVAIL)
        pIoParameter->ulPrnCtl = PebRegGet(REG_Prn_Ctl, MSK_Prn_Ctl);
    else
        pIoParameter->ulPrnCtl = 0;
    
    // INTAװ쥸ͤγǼ
    if (_iDevOpeStat != EIOVDEVUNAVAIL)
        pIoParameter->ulIntReq = PebRegGet(REG_Int_Req, MSK_Int_Req);
    else
        pIoParameter->ulIntReq = 0;
    
    // INTAޥ쥸ͤγǼ
    if (_iDevOpeStat != EIOVDEVUNAVAIL)
        pIoParameter->ulIntMsk = PebRegGet(REG_Int_Msk, MSK_Int_Msk);
    else
        pIoParameter->ulIntMsk = 0;
    
    #ifdef _DEBUG
    printk("%s: pIoParameter->ulDevErrorNo = %lu\n",   PRN_DEV_NAME, pIoParameter->ulDevErrorNo);
    printk("%s: pIoParameter->ulDevOpeStat = %lu\n",   PRN_DEV_NAME, pIoParameter->ulDevOpeStat);
    printk("%s: pIoParameter->ulPebOpeStat = %lu\n",   PRN_DEV_NAME, pIoParameter->ulPebOpeStat);
    printk("%s: pIoParameter->ulPebPrnStat = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPebPrnStat);
    printk("%s: pIoParameter->ulPDMACtl    = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPDMACtl);
    printk("%s: pIoParameter->ulUnitCtl    = %08lX\n", PRN_DEV_NAME, pIoParameter->ulUnitCtl);
    printk("%s: pIoParameter->ulPrnCtl     = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPrnCtl);
    printk("%s: pIoParameter->ulPrtState   = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPrtState);
    printk("%s: pIoParameter->ulIntReq     = %08lX\n", PRN_DEV_NAME, pIoParameter->ulIntReq);
    printk("%s: pIoParameter->ulIntMsk     = %08lX\n", PRN_DEV_NAME, pIoParameter->ulIntMsk);
    #endif
    
    // ｪλ
    iResult = 0;
    
    // λ
    #ifdef _DEBUG
    printk("%s: IoctlGetStat: OUT(%d)\n", PRN_DEV_NAME, iResult);
    #endif
    return (iResult);
}

/*==========================================================================*
 *
 *  PEB쥸
 *
 *==========================================================================*
 *
 *εǽ
 *  I/Oȥ᥽åɤƤФؿ
 *  I/Oѥ᡼򸵤PEB쥸ͤꤹ롣
 *
 *η
 *  int IoctlSetReg(
 *      EIOPSETREG *pIoParameter    // [I] I/Oѥ᡼
 *  );
 *
 *͡
 *  ｪλ        : 0
 *  ꥽  : -EBUSY
 *
 *ա
 *  ǥХ֤Ԥʳξϥӥ
 *
 *==========================================================================*/
static int IoctlSetReg(EIOPSETREG *pIoParameter)
{
    int iResult = -EBUSY;
    
    // 
    #ifdef _DEBUG
    printk("%s: IoctlSetReg: IN(%p)\n", PRN_DEV_NAME, pIoParameter);
    #endif
    
    // ǥХ֤Ԥʳξϥ꥽
    if (_iDevOpeStat != EIOVDEVIDLE)
        goto end;
    
    #ifdef _DEBUG
    printk("%s: pIoParameter->ulPebRegAddr = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPebRegAddr);
    printk("%s: pIoParameter->ulPebRegData = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPebRegData);
    #endif
    
    // ѥ᡼ꤵ줿쥸˥ѥ᡼ͤ饤
    PebRegPut(pIoParameter->ulPebRegAddr, ~0, pIoParameter->ulPebRegData);
    
    // ｪλ
    iResult = 0;
    
end:
    // λ
    #ifdef _DEBUG
    printk("%s: IoctlSetReg: OUT(%d)\n", PRN_DEV_NAME, iResult);
    #endif
    return (iResult);
}

/*==========================================================================*
 *
 *  PEB쥸
 *
 *==========================================================================*
 *
 *εǽ
 *  I/Oȥ᥽åɤƤФؿ
 *  I/Oѥ᡼򸵤PEB쥸ͤ롣
 *
 *η
 *  int IoctlGetReg(
 *      EIOPGETREG *pIoParameter    // [I] I/Oѥ᡼
 *  );
 *
 *͡
 *  ｪλ        : 0
 *  ꥽  : -EBUSY
 *
 *ա
 *  ǥХ֤ԲĤξϥӥ
 *
 *==========================================================================*/
static int IoctlGetReg(EIOPGETREG *pIoParameter)
{
    int iResult = -EBUSY;
    
    // 
    #ifdef _DEBUG
    printk("%s: IoctlGetReg: IN(%p)\n", PRN_DEV_NAME, pIoParameter);
    #endif
    
    // ǥХ֤ԲĤξϥ꥽
    if (_iDevOpeStat == EIOVDEVUNAVAIL)
        goto end;
    
    #ifdef _DEBUG
    printk("%s: pIoParameter->ulPebRegAddr = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPebRegAddr);
    #endif
    
    // ѥ᡼ꤵ줿쥸꡼
    pIoParameter->ulPebRegData = PebRegGet(pIoParameter->ulPebRegAddr, ~0);
    
    #ifdef _DEBUG
    printk("%s: pIoParameter->ulPebRegData = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPebRegData);
    #endif
    
    // ｪλ
    iResult = 0;
    
end:
    // λ
    #ifdef _DEBUG
    printk("%s: IoctlGetReg: OUT(%d)\n", PRN_DEV_NAME, iResult);
    #endif
    return (iResult);
}

/*==========================================================================*
 *
 *  PEB
 *
 *==========================================================================*
 *
 *εǽ
 *  I/Oȥ᥽åɤƤФؿ
 *  I/Oѥ᡼򸵤PEBͤꤹ롣
 *
 *η
 *  int IoctlSetMem(
 *      EIOPSETMEM *pIoParameter    // [I] I/Oѥ᡼
 *  );
 *
 *͡
 *  ｪλ        : 0
 *  ꥽  : -EBUSY
 *
 *ա
 *  ǥХ֤Ԥʳξϥӥ
 *
 *==========================================================================*/
static int IoctlSetMem(EIOPSETMEM *pIoParameter)
{
    int iResult = -EBUSY;
    
    // 
    #ifdef _DEBUG
    printk("%s: IoctlSetMem: IN(%p)\n", PRN_DEV_NAME, pIoParameter);
    #endif
    
    // ǥХ֤Ԥʳξϥ꥽
    if (_iDevOpeStat != EIOVDEVIDLE)
        goto end;
    
    #ifdef _DEBUG
    printk("%s: pIoParameter->ulPebMemAddr = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPebMemAddr);
    printk("%s: pIoParameter->ulPebMemData = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPebMemData);
    #endif
    
    // ѥ᡼ꤵ줿˥ѥ᡼ͤ饤
    PebMemPut(pIoParameter->ulPebMemAddr, pIoParameter->ulPebMemData);
    
    // ｪλ
    iResult = 0;
    
end:
    // λ
    #ifdef _DEBUG
    printk("%s: IoctlSetMem: OUT(%d)\n", PRN_DEV_NAME, iResult);
    #endif
    return (iResult);
}

/*==========================================================================*
 *
 *  PEB
 *
 *==========================================================================*
 *
 *εǽ
 *  I/Oȥ᥽åɤƤФؿ
 *  I/Oѥ᡼򸵤PEBͤ롣
 *
 *η
 *  int IoctlGetMem(
 *      EIOPGETMEM *pIoParameter    // [I] I/Oѥ᡼
 *  );
 *
 *͡
 *  ｪλ        : 0
 *  ꥽  : -EBUSY
 *
 *ա
 *  ǥХ֤ԲĤξϥӥ
 *
 *==========================================================================*/
static int IoctlGetMem(EIOPGETMEM *pIoParameter)
{
    int iResult = -EBUSY;
    
    // 
    #ifdef _DEBUG
    printk("%s: IoctlGetMem: IN(%p)\n", PRN_DEV_NAME, pIoParameter);
    #endif
    
    // ǥХ֤ԲĤξϥ꥽
    if (_iDevOpeStat == EIOVDEVUNAVAIL)
        goto end;
    
    #ifdef _DEBUG
    printk("%s: pIoParameter->ulPebMemAddr = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPebMemAddr);
    #endif
    
    // ѥ᡼ꤵ줿꡼
    pIoParameter->ulPebMemData = PebMemGet(pIoParameter->ulPebMemAddr);
    
    #ifdef _DEBUG
    printk("%s: pIoParameter->ulPebMemData = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPebMemData);
    #endif
    
    // ｪλ
    iResult = 0;
    
end:
    // λ
    #ifdef _DEBUG
    printk("%s: IoctlGetMem: OUT(%d)\n", PRN_DEV_NAME, iResult);
    #endif
    return (iResult);
}

/*==========================================================================*
 *
 *  FLASH
 *
 *==========================================================================*
 *
 *εǽ
 *  I/Oȥ᥽åɤƤФؿ
 *  I/Oѥ᡼򸵤FLASHꤹ롣
 *  ʤꤹǡϥǥХХåե롣
 *
 *η
 *  int IoctlSetFlash(
 *      EIOPSETFLASH *pIoParameter  // [I] I/Oѥ᡼
 *  );
 *
 *͡
 *  ｪλ        : 0
 *  ꥽  : -EBUSY
 *
 *ա
 *  ǥХ֤Ԥʳξϥӥ
 *  FLASHϡFPGAե졼ΰ裱Хååѡ
 *  FPGAե졼ΰ裲򹹿ѤȤƹ롣
 *  FPGAե졼ΰ裱Ӥɤ߹ѤȤ뤿ᡢ
 *  ꤹΰɬŪFPGAե졼ΰ裲Ȥʤ롣
 *
 *==========================================================================*/
static int IoctlSetFlash(EIOPSETFLASH *pIoParameter)
{
    int iResult = -EBUSY;
    unsigned long *pulFlashMemAddr;
    long lSetWatchTime, lSetBaseTime, lSetNowTime;
    struct timeval tvNow;
    unsigned int uTopAddr, uEndAddr, uSetAddr, uSetAddr2;
    
    // 
    #ifdef _DEBUG
    printk("%s: IoctlSetFlash: IN(%p)\n", PRN_DEV_NAME, pIoParameter);
    #endif
    
    // ǥХ֤Ԥʳξϥ꥽
    if (_iDevOpeStat != EIOVDEVIDLE)
        goto end;
    
    #ifdef _DEBUG
    printk("%s: pIoParameter->ulPebRomAddr   = %lu\n", PRN_DEV_NAME, pIoParameter->ulPebRomAddr);
    printk("%s: pIoParameter->ulSetWatchTime = %lu\n", PRN_DEV_NAME, pIoParameter->ulSetWatchTime);
    #endif
    
    // ѥ᡼ꤵ줿ǧԤ(ms)ץǧԤ(us)
    lSetWatchTime = pIoParameter->ulSetWatchTime * 1000;
    
    // FLASH񤭹Ƭɥ쥹Υå
    pulFlashMemAddr = (unsigned long *)_pucPebRomAddr;
    uTopAddr = pIoParameter->ulPebRomAddr - PEB_ROM_ADDR;
    
    // ǥХХåեǡ򸵤FLASH񤭹߽üɥ쥹Υå
    uEndAddr = uTopAddr + (_uDevDataLen << 2);
    
    // ̤ν
    pIoParameter->ulSetResult = EIOVFLWRITEOK;
    
    // FLASHߵĥ쥸FLWå
    PebRegBitSet(REG_FL_Write, BIT_FLW);
    
    // ꥻåȥޥɽ񤭹
    PebRegPut(REG_FL_HAdr, MSK_FL_HAdr, 0);
    FlashMemPut(&pulFlashMemAddr[0x000], 0xf0);
    
    // ǥХХåեǡʬʲν򷫤֤
    uSetAddr = 0;
    for (uSetAddr2 = uTopAddr; uSetAddr2 < uEndAddr; uSetAddr2 += sizeof(unsigned long))
    {
        // ߻μ
        do_gettimeofday(&tvNow);
        lSetBaseTime = tvNow.tv_usec;
        
        // Хȥ⡼ɻǤΥץॳޥɽ񤭹
        PebRegPut(REG_FL_HAdr, MSK_FL_HAdr, 0);
        FlashMemPut(&pulFlashMemAddr[0xaaa], 0xaa);                                         // 1stХ饤ȥΥɥ쥹AAAhϢΥǡAAh
        FlashMemPut(&pulFlashMemAddr[0x555], 0x55);                                         // 2ndХ饤ȥΥɥ쥹555hϢΥǡ55h
        FlashMemPut(&pulFlashMemAddr[0xaaa], 0xa0);                                         // 3rdХ饤ȥΥɥ쥹AAAhϢΥǡA0h
        
        // ץоݤȤʤ륢ɥ쥹˥ǡ
        PebRegPut(REG_FL_HAdr, MSK_FL_HAdr, uSetAddr2 >> 14);
        FlashMemPut(&pulFlashMemAddr[(uSetAddr2 >> 2) & 0xfff], _pucDevDataBuff[uSetAddr]); // 4thХ饤ȥΥץॢɥ쥹ϢΥǡ
        
        // FLASHߵĥ쥸򸵤˽񤭹߾֤Ѱܤå
        // FLBSY=0+BSYLAT=1äơ񤭹ߴλ
        // ʤѰܤʤȤθޡ򤫤ޤ
        while ((PebRegGet(REG_FL_Write, MSK_FL_Write) & (BIT_FLBSY | BIT_BSYLAT)) != BIT_BSYLAT)
        {
            // ߻μ
            do_gettimeofday(&tvNow);
            lSetNowTime = tvNow.tv_usec;
            
            // ॢȥå
            if (lSetNowTime < lSetBaseTime)
                lSetNowTime += 1000000;
            if ((lSetNowTime - lSetBaseTime) > lSetWatchTime)
            {
                PebRegBitClr(REG_FL_Write, BIT_BSYLAT);
                pIoParameter->ulSetResult = EIOVFLWRITETO;  // 񤭹ߥॢ
                goto skip;
            }
        }
        PebRegBitClr(REG_FL_Write, BIT_BSYLAT);
        
        // ٥եå
        PebRegPut(REG_FL_HAdr, MSK_FL_HAdr, uSetAddr2 >> 14);
        if (FlashMemGet(&pulFlashMemAddr[(uSetAddr2 >> 2) & 0xfff]) != _pucDevDataBuff[uSetAddr])
        {
            pIoParameter->ulSetResult = EIOVFLWRITENG;  // 񤭹ߥå顼
            goto skip;
        }
        uSetAddr ++;
    }
    
skip:
    // FLASHߵĥ쥸FLWꥢ
    PebRegBitClr(REG_FL_Write, BIT_FLW);
    
    #ifdef _DEBUG
    printk("%s: pIoParameter->ulSetResult    = %lu\n", PRN_DEV_NAME, pIoParameter->ulSetResult);
    #endif
    
    // ｪλ
    iResult = 0;
    
end:
    // λ
    #ifdef _DEBUG
    printk("%s: IoctlSetFlash: OUT(%d)\n", PRN_DEV_NAME, iResult);
    #endif
    return (iResult);
}

/*==========================================================================*
 *
 *  FLASH
 *
 *==========================================================================*
 *
 *εǽ
 *  I/Oȥ᥽åɤƤФؿ
 *  I/Oѥ᡼򸵤FLASH롣
 *  ʤǡϥǥХХåեسǼ롣
 *
 *η
 *  int IoctlGetFlash(
 *      EIOPGETFLASH *pIoParameter  // [I] I/Oѥ᡼
 *  );
 *
 *͡
 *  ｪλ        : 0
 *  ꥽  : -EBUSY
 *
 *ա
 *  ǥХ֤Ԥʳξϥӥ
 *
 *==========================================================================*/
static int IoctlGetFlash(EIOPGETFLASH *pIoParameter)
{
    int iResult = -EBUSY;
    unsigned long *pulFlashMemAddr;
    unsigned int uTopAddr, uEndAddr, uGetAddr, uGetAddr2;
    
    // 
    #ifdef _DEBUG
    printk("%s: IoctlGetFlash: IN(%p)\n", PRN_DEV_NAME, pIoParameter);
    #endif
    
    // ǥХ֤Ԥʳξϥ꥽
    if (_iDevOpeStat != EIOVDEVIDLE)
        goto end;
    
    #ifdef _DEBUG
    printk("%s: pIoParameter->ulPebRomAddr = %lu\n", PRN_DEV_NAME, pIoParameter->ulPebRomAddr);
    printk("%s: pIoParameter->ulGetSize    = %lu\n", PRN_DEV_NAME, pIoParameter->ulGetSize);
    #endif
    
    // FLASHɤ߹Ƭɥ쥹Υå
    pulFlashMemAddr = (unsigned long *)_pucPebRomAddr;
    uTopAddr = pIoParameter->ulPebRomAddr - PEB_ROM_ADDR;
    
    // ѥ᡼ꤵ줿FLASH򸵤FLASHɤ߹߽üɥ쥹Υå
    uEndAddr = uTopAddr + (pIoParameter->ulGetSize << 2);
    
    // FLASHߵĥ쥸FLWå
    PebRegBitSet(REG_FL_Write, BIT_FLW);
    
    // ꥻåȥޥɽ񤭹
    PebRegPut(REG_FL_HAdr, MSK_FL_HAdr, 0);
    FlashMemPut(&pulFlashMemAddr[0x000], 0xf0);
    
    // ѥ᡼ꤵ줿FLASHʬʲν򷫤֤
    uGetAddr = 0;
    for (uGetAddr2 = uTopAddr; uGetAddr2 < uEndAddr; uGetAddr2 += sizeof(unsigned long))
    {
        // Хȥ⡼ɻǤΥ꡼ɥޥɽ񤭹
        PebRegPut(REG_FL_HAdr, MSK_FL_HAdr, 0);
        FlashMemPut(&pulFlashMemAddr[0xaaa], 0xaa);                                             // 1stХ饤ȥΥɥ쥹AAAhϢΥǡAAh
        FlashMemPut(&pulFlashMemAddr[0x555], 0x55);                                             // 2ndХ饤ȥΥɥ쥹555hϢΥǡ55h
        FlashMemPut(&pulFlashMemAddr[0xaaa], 0xf0);                                             // 3rdХ饤ȥΥɥ쥹AAAhϢΥǡF0h
        
        // ꡼оݤȤʤ륢ɥ쥹ǡ
        PebRegPut(REG_FL_HAdr, MSK_FL_HAdr, uGetAddr2 >> 14);
        _pucDevDataBuff[uGetAddr] = FlashMemGet(&pulFlashMemAddr[(uGetAddr2 >> 2) & 0xfff]);    // 4thХ饤ȥΥ꡼ɥɥ쥹ϢΥǡ
        uGetAddr ++;
    }
    
    // FLASHߵĥ쥸FLWꥢ
    PebRegBitClr(REG_FL_Write, BIT_FLW);
    
    // ǥХХåեǡι
    _uDevDataLen = uGetAddr;
    
    // ｪλ
    iResult = 0;
    
end:
    // λ
    #ifdef _DEBUG
    printk("%s: IoctlGetFlash: OUT(%d)\n", PRN_DEV_NAME, iResult);
    #endif
    return (iResult);
}

/*==========================================================================*
 *
 *  PEBƥȽ
 *
 *==========================================================================*
 *
 *εǽ
 *  I/Oȥ᥽åɤƤФؿ
 *  I/Oѥ᡼򸵤˥ϡɥǤ»ܤ롣
 *
 *η
 *  int IoctlPebTest(
 *      EIOPPEBTEST *pIoParameter   // [I] I/Oѥ᡼
 *  );
 *
 *͡
 *  ｪλ        : 0
 *  ꥽  : -EBUSY
 *
 *ա
 *  ǥХ֤Ԥʳξϥӥ
 *
 *==========================================================================*/
static int IoctlPebTest(EIOPPEBTEST *pIoParameter)
{
    int iResult = -EBUSY;
    
    // 
    #ifdef _DEBUG
    printk("%s: IoctlPebTest: IN(%p)\n", PRN_DEV_NAME, pIoParameter);
    #endif
    
    // ǥХ֤Ԥʳξϥ꥽
    if (_iDevOpeStat != EIOVDEVIDLE)
        goto end;
    
    #ifdef _DEBUG
    printk("%s: pIoParameter->ulTestType = %lu\n", PRN_DEV_NAME, pIoParameter->ulTestType);
    #endif
    
    // ѥ᡼ꤵ줿ƥȥפǡХƥȻ
    if (pIoParameter->ulTestType == EIOVTESTDATABUS)
    {
        // ǡХƥ
        if (DataBusTest() == 0)
            pIoParameter->ulTestResult = EIOVTESTOK;
        else
            pIoParameter->ulTestResult = EIOVTESTNG;
    }
    
    // Ǥʤɥ쥹ХƥȻ
    else if (pIoParameter->ulTestType == EIOVTESTADDRBUS)
    {
        // ɥ쥹Хƥ
        if (AddrBusTest() == 0)
            pIoParameter->ulTestResult = EIOVTESTOK;
        else
            pIoParameter->ulTestResult = EIOVTESTNG;
    }
    
    // ǤʤꥳڥƥȻ
    else if (pIoParameter->ulTestType == EIOVTESTMEMCOMP)
    {
        // ꥳڥƥ
        if (MemCompTest() == 0)
            pIoParameter->ulTestResult = EIOVTESTOK;
        else
            pIoParameter->ulTestResult = EIOVTESTNG;
    }
    
    #ifdef _DEBUG
    printk("%s: pIoParameter->ulTestResult = %lu\n", PRN_DEV_NAME, pIoParameter->ulTestResult);
    #endif
    
    // ｪλ
    iResult = 0;
    
end:
    // λ
    #ifdef _DEBUG
    printk("%s: IoctlPebTest: OUT(%d)\n", PRN_DEV_NAME, iResult);
    #endif
    return (iResult);
}

/*==========================================================================*
 *
 *  Ϫ
 *
 *==========================================================================*
 *
 *εǽ
 *  I/Oȥ᥽åɤƤФؿ
 *  I/Oѥ᡼򸵤Ϫ֤ꤹ롣
 *
 *η
 *  int IoctlSetExp(
 *      EIOPSETEXP *pIoParameter    // [I] I/Oѥ᡼
 *  );
 *
 *͡
 *  ｪλ        : 0
 *  ꥽  : -EBUSY
 *
 *ա
 *  ǥХ֤Ԥʳξϥӥ
 *
 *==========================================================================*/
static int IoctlSetExp(EIOPSETEXP *pIoParameter)
{
    int iResult = -EBUSY;
    unsigned long ulPrnCtl;
    
    // 
    #ifdef _DEBUG
    printk("%s: IoctlSetExp: IN(%p)\n", PRN_DEV_NAME, pIoParameter);
    #endif
    
    // ǥХ֤Ԥʳξϥ꥽
    if (_iDevOpeStat != EIOVDEVIDLE)
        goto end;
    
    #ifdef _DEBUG
    printk("%s: pIoParameter->ulExpMode     = %lu\n",   PRN_DEV_NAME, pIoParameter->ulExpMode);
    printk("%s: pIoParameter->ulChkMode     = %lu\n",   PRN_DEV_NAME, pIoParameter->ulChkMode);
    printk("%s: pIoParameter->ulMntMode     = %lu\n",   PRN_DEV_NAME, pIoParameter->ulMntMode);
    printk("%s: pIoParameter->ulLaserMode   = %lu\n",   PRN_DEV_NAME, pIoParameter->ulLaserMode);
    printk("%s: pIoParameter->ulPolygonMode = %lu\n",   PRN_DEV_NAME, pIoParameter->ulPolygonMode);
    printk("%s: pIoParameter->ulPolygonSize = %lu\n",   PRN_DEV_NAME, pIoParameter->ulPolygonSize);
    printk("%s: pIoParameter->ulPolygonTime = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPolygonTime);
    printk("%s: pIoParameter->ulBriHsync    = %08lX\n", PRN_DEV_NAME, pIoParameter->ulBriHsync);
    printk("%s: pIoParameter->ulTopHsync    = %08lX\n", PRN_DEV_NAME, pIoParameter->ulTopHsync);
    printk("%s: pIoParameter->ulEndHsync    = %08lX\n", PRN_DEV_NAME, pIoParameter->ulEndHsync);
    #endif
    
    // ѥ᡼ꤵ줿Ϫ⡼ɤ̾⡼ɻ
    if (pIoParameter->ulExpMode == EIOVEXPNORMAL)
    {
        // ץ쥸Υ꡼
        ulPrnCtl = PebRegGet(REG_Prn_Ctl, MSK_Prn_Ctl);
        
        // ѥ᡼ꤵ줿졼⡼ɤ򸵤˥ץ쥸ͤPCTLLDONå
        if (pIoParameter->ulLaserMode == EIOVLASEROFF)
            ulPrnCtl &= ~BIT_PCTLLDON;
        else
            ulPrnCtl |=  BIT_PCTLLDON;
        
        // ѥ᡼ꤵ줿ݥꥴ⡼ɤ򸵤˥ץ쥸ͤPCTLPONå
        if (pIoParameter->ulPolygonMode == EIOVPOLYGONOFF)
            ulPrnCtl &= ~BIT_PCTLPON;
        else
            ulPrnCtl |=  BIT_PCTLPON;
        
        // ѥ᡼ꤵ줿ݥꥴ⡼ɤݥꥴONξ
        if (pIoParameter->ulPolygonMode == EIOVPOLYGONON)
        {
            // HSYNCиͤHSYNCи̥쥸˥饤
            PebRegPut(REG_Bri_Hsync, MSK_Bri_Hsync, pIoParameter->ulBriHsync);
            
            // HSYNCгϰ֤HSYNCгϰ֥쥸˥饤
            PebRegPut(REG_Start_Hsync, MSK_Start_Hsync, pIoParameter->ulTopHsync);
            
            // HSYNCнλ֤HSYNCнλ֥쥸˥饤
            PebRegPut(REG_Stop_Hsync, MSK_Stop_Hsync, pIoParameter->ulEndHsync);
        }
        
        // ѥ᡼ꤵ줿ݥꥴž򸵤˥ץ쥸ͤPCTLSIZEå
        if (pIoParameter->ulPolygonSize == EIOVSIZE4375)
            ulPrnCtl &= ~BIT_PCTLSIZE;
        else
            ulPrnCtl |=  BIT_PCTLSIZE;
        
        // ץ쥸ͤץ쥸˥饤
        PebRegPut(REG_Prn_Ctl, MSK_Prn_Ctl, ulPrnCtl);
    }
    
    // Ǥʤå⡼ɻ
    else if (pIoParameter->ulExpMode == EIOVEXPCHECK)
    {
        // ѥ᡼ꤵ줿å⡼ɤݥꥴåϻ
        if (pIoParameter->ulChkMode == EIOVCHKPSTART)
        {
            // ץ쥸PCTLPONå
            PebRegBitSet(REG_Prn_Ctl, BIT_PCTLPON);
        }
        
        // Ǥʤ졼åϻ
        else if (pIoParameter->ulChkMode == EIOVCHKLSTART)
        {
            // ƥȥ⡼ɥ쥸TMDFDOå
            PebRegBitSet(REG_Test_Mode, BIT_TMDFDO);
            
            // ̤HSYNCи̥쥸˥饤
            PebRegPut(REG_Bri_Hsync, MSK_Bri_Hsync, ~0);
            
            // ץ쥸PCTLLDONå
            PebRegBitSet(REG_Prn_Ctl, BIT_PCTLLDON);
        }
        
        // ǤʤHSYNCåϻ
        else if (pIoParameter->ulChkMode == EIOVCHKHSTART)
        {
            // HSYNCиͤHSYNCи̥쥸˥饤
            PebRegPut(REG_Bri_Hsync, MSK_Bri_Hsync, pIoParameter->ulBriHsync);
            
            // Ϫå쥸ꥢ
            PebRegPut(REG_Exp_Latch, MSK_Exp_Latch, 0);
        }
        
        // Ǥʤåλ
        else if (pIoParameter->ulChkMode == EIOVCHKEND)
        {
            // ץ쥸PCTLLDON/PCTLPONꥢ
            PebRegBitClr(REG_Prn_Ctl, BIT_PCTLLDON | BIT_PCTLPON);
            
            // Ϫå쥸ꥢ
            PebRegPut(REG_Exp_Latch, MSK_Exp_Latch, 0);
            
            // ƥȥ⡼ɥ쥸TMDFDOꥢ
            PebRegBitClr(REG_Test_Mode, BIT_TMDFDO);
        }
    }
    
    // Ǥʤƥʥ󥹥⡼ɻ
    else if (pIoParameter->ulExpMode == EIOVEXPMAINTE)
    {
        // ѥ᡼ꤵ줿ƥʥ󥹥⡼ɤƥʥ󥹳ϻ
        if (pIoParameter->ulMntMode == EIOVMNTSTART)
        {
            // ƥȥ⡼ɥ쥸TMDFDOå
            PebRegBitSet(REG_Test_Mode, BIT_TMDFDO);
            
            // ѥ᡼ꤵ줿HSYNCи̤HSYNCи̥쥸˥饤
            PebRegPut(REG_Bri_Hsync, MSK_Bri_Hsync, pIoParameter->ulBriHsync);
            
            // Ϫå쥸ꥢ
            PebRegPut(REG_Exp_Latch, MSK_Exp_Latch, 0);
            
            // ץ쥸Υ꡼
            ulPrnCtl = PebRegGet(REG_Prn_Ctl, MSK_Prn_Ctl);
            
            // ѥ᡼ꤵ줿졼⡼ɤ򸵤˥ץ쥸ͤPCTLLDONå
            if (pIoParameter->ulLaserMode == EIOVLASEROFF)
                ulPrnCtl &= ~BIT_PCTLLDON;
            else
                ulPrnCtl |=  BIT_PCTLLDON;
            
            // ѥ᡼ꤵ줿ݥꥴ⡼ɤ򸵤˥ץ쥸ͤPCTLPONå
            if (pIoParameter->ulPolygonMode == EIOVPOLYGONOFF)
                ulPrnCtl &= ~BIT_PCTLPON;
            else
                ulPrnCtl |=  BIT_PCTLPON;
            
            // ѥ᡼ꤵ줿ݥꥴž֤ץ쥸ͤ˥å
            ulPrnCtl &= ~BIT_POT;
            ulPrnCtl |= (pIoParameter->ulPolygonTime << 16);
            
            // ץ쥸ͤץ쥸˥饤
            PebRegPut(REG_Prn_Ctl, MSK_Prn_Ctl, ulPrnCtl);
        }
        
        // Ǥʤƥʥ󥹳ǧ
        else if (pIoParameter->ulMntMode == EIOVMNTCHECK)
        {
            // Ϫå쥸ꥢ
            PebRegPut(REG_Exp_Latch, MSK_Exp_Latch, 0);
        }
        
        // Ǥʤƥʥ󥹽λ
        else if (pIoParameter->ulMntMode == EIOVMNTEND)
        {
            // ץ쥸PCTLLDON/PCTLPONꥢ
            PebRegBitClr(REG_Prn_Ctl, BIT_PCTLLDON | BIT_PCTLPON);
            
            // ƥȥ⡼ɥ쥸TMDFDOꥢ
            PebRegBitClr(REG_Test_Mode, BIT_TMDFDO);
            
            // Ϫå쥸ꥢ
            PebRegPut(REG_Exp_Latch, MSK_Exp_Latch, 0);
        }
    }
    
    // ｪλ
    iResult = 0;
    
end:
    // λ
    #ifdef _DEBUG
    printk("%s: IoctlSetExp: OUT(%d)\n", PRN_DEV_NAME, iResult);
    #endif
    return (iResult);
}

/*==========================================================================*
 *
 *  Ϫּ
 *
 *==========================================================================*
 *
 *εǽ
 *  I/Oȥ᥽åɤƤФؿ
 *  I/Oѥ᡼򸵤Ϫ֤롣
 *
 *η
 *  int IoctlGetExp(
 *      EIOPGETEXP *pIoParameter    // [I] I/Oѥ᡼
 *  );
 *
 *͡
 *  ｪλ        : 0
 *  ꥽  : -EBUSY
 *
 *ա
 *  ǥХ֤ԲĤξϥӥ
 *
 *==========================================================================*/
static int IoctlGetExp(EIOPGETEXP *pIoParameter)
{
    int iResult = -EBUSY;
    unsigned long ulPrnCtl, ulPrtState;
    
    // 
    #ifdef _DEBUG
    printk("%s: IoctlGetExp: IN(%p)\n", PRN_DEV_NAME, pIoParameter);
    #endif
    
    // ǥХ֤ԲĤξϥ꥽
    if (_iDevOpeStat == EIOVDEVUNAVAIL)
        goto end;
    
    // ץ쥸Υ꡼
    ulPrnCtl = PebRegGet(REG_Prn_Ctl, MSK_Prn_Ctl);
    
    // ץ쥸ͤ졼⡼ɤγǼ
    if (ulPrnCtl & BIT_PCTLLDON)
        pIoParameter->ulLaserMode = EIOVLASERON;
    else
        pIoParameter->ulLaserMode = EIOVLASEROFF;
    
    // ץ쥸ͤݥꥴ⡼ɤγǼ
    if (ulPrnCtl & BIT_PCTLPON)
        pIoParameter->ulPolygonMode = EIOVPOLYGONON;
    else
        pIoParameter->ulPolygonMode = EIOVPOLYGONOFF;
    
    // ץ쥸ͤݥꥴžγǼ
    if (ulPrnCtl & BIT_PCTLSIZE)
        pIoParameter->ulPolygonSize = EIOVSIZE2500;
    else
        pIoParameter->ulPolygonSize = EIOVSIZE4375;
    
    // ѥ᡼ꤵ줿ݥꥴž֤ץ쥸ͤ˥å
    pIoParameter->ulPolygonTime = (ulPrnCtl & BIT_POT) >> 16;
    
    // Ϫ滲ȥ쥸ͤ򸵤Ϫ֤γǼ
    pIoParameter->ulExpRead = PebRegGet(REG_Exp_Read, MSK_Exp_Read);
    
    // Ϫå쥸ͤ򸵤Ϫå֤γǼ
    pIoParameter->ulExpLatch = PebRegGet(REG_Exp_Latch, MSK_Exp_Latch);
    
    // ץȥơ쥸Υ꡼
    ulPrtState = PebRegGet(REG_Prt_State, MSK_Prt_State);
    
    // ץȥơ쥸ͤݥꥴ֤γǼ
    pIoParameter->ulPolygonStat = (ulPrtState & BIT_PRPS) >> 12;
    
    // ץȥơ쥸ͤPEB顼ɤγǼ
    pIoParameter->ulPebErrCode = (ulPrtState & BIT_PRSE) >> 8;
    
    #ifdef _DEBUG
    printk("%s: pIoParameter->ulLaserMode   = %lu\n",   PRN_DEV_NAME, pIoParameter->ulLaserMode);
    printk("%s: pIoParameter->ulPolygonMode = %lu\n",   PRN_DEV_NAME, pIoParameter->ulPolygonMode);
    printk("%s: pIoParameter->ulPolygonSize = %lu\n",   PRN_DEV_NAME, pIoParameter->ulPolygonSize);
    printk("%s: pIoParameter->ulPolygonTime = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPolygonTime);
    printk("%s: pIoParameter->ulExpRead     = %08lX\n", PRN_DEV_NAME, pIoParameter->ulExpRead);
    printk("%s: pIoParameter->ulExpLatch    = %08lX\n", PRN_DEV_NAME, pIoParameter->ulExpLatch);
    printk("%s: pIoParameter->ulPolygonStat = %lu\n",   PRN_DEV_NAME, pIoParameter->ulPolygonStat);
    printk("%s: pIoParameter->ulPebErrCode  = %lu\n",   PRN_DEV_NAME, pIoParameter->ulPebErrCode);
    #endif
    
    // ｪλ
    iResult = 0;
    
end:
    // λ
    #ifdef _DEBUG
    printk("%s: IoctlGetExp: OUT(%d)\n", PRN_DEV_NAME, iResult);
    #endif
    return (iResult);
}

/*==========================================================================*
 *
 *  DMA
 *
 *==========================================================================*
 *
 *εǽ
 *  I/Oȥ᥽åɤƤФؿ
 *  I/Oѥ᡼򸵤DMA¹Ԥ롣
 *
 *η
 *  int IoctlOpeDma(
 *      EIOPOPEDMA *pIoParameter    // [I] I/Oѥ᡼
 *  );
 *
 *͡
 *  ｪλ        : 0
 *  ꥽  : -EBUSY
 *
 *ա
 *  ǥХ֤Ԥʳξϥӥ
 *
 *==========================================================================*/
static int IoctlOpeDma(EIOPOPEDMA *pIoParameter)
{
    int iResult = -EBUSY;
    unsigned long ulPDMACtl;
    
    // 
    #ifdef _DEBUG
    printk("%s: IoctlOpeDma: IN(%p)\n", PRN_DEV_NAME, pIoParameter);
    #endif
    
    // ǥХ֤Ԥʳξϥ꥽
    if (_iDevOpeStat != EIOVDEVIDLE)
        goto end;
    
    #ifdef _DEBUG
    printk("%s: pIoParameter->ulDmaType     = %lu\n",   PRN_DEV_NAME, pIoParameter->ulDmaType);
    printk("%s: pIoParameter->ulDmaMode     = %lu\n",   PRN_DEV_NAME, pIoParameter->ulDmaMode);
    printk("%s: pIoParameter->ulDmaDir      = %lu\n",   PRN_DEV_NAME, pIoParameter->ulDmaDir);
    printk("%s: pIoParameter->ulDevBuffAddr = %08lX\n", PRN_DEV_NAME, pIoParameter->ulDevBuffAddr);
    printk("%s: pIoParameter->ulPebMemAddr  = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPebMemAddr);
    printk("%s: pIoParameter->ulDmaSize     = %08lX\n", PRN_DEV_NAME, pIoParameter->ulDmaSize);
    printk("%s: pIoParameter->ulImgILPix    = %08lX\n", PRN_DEV_NAME, pIoParameter->ulImgILPix);
    printk("%s: pIoParameter->ulImgIHPix    = %08lX\n", PRN_DEV_NAME, pIoParameter->ulImgIHPix);
    #endif
    
    // ѥ᡼ꤵ줿ǥХХåեեåȥɥ쥹򸵤DMAѥǥХХåեեåȥɥ쥹
    _ulDmaDevBuffAddr = pIoParameter->ulDevBuffAddr;
    
    // ѥ᡼ꤵ줿PEB륢ɥ쥹򸵤DMAPEB륢ɥ쥹
    _ulDmaPebMemAddr = pIoParameter->ulPebMemAddr;
    
    // ѥ᡼ꤵ줿DMAžDMAžȡ륵
    _ulDmaTotalSize = pIoParameter->ulDmaSize;
    
    // DMAžѤߥν
    _ulDmaSentSize = 0;
    
    // DMAžλ
    _ulDmaSendSize = _ulDmaTotalSize;
    if (_ulDmaSendSize > (unsigned long)_uDmaBuffSize)
        _ulDmaSendSize = (unsigned long)_uDmaBuffSize;
    
    // ѥ᡼ꤵ줿DMAžM/BPEBξ硢DMAڡΥ饤
    if (pIoParameter->ulDmaDir == EIOVDMAWRITE)
        _ulDmaSendSize = DmaPageWrite(_ulDmaDevBuffAddr, _ulDmaSendSize);
    
    // DMAPCIХɥ쥹PCI-DMAPCIɥ쥹쥸˥饤
    PebRegPut(REG_PDMA_PAdr, MSK_PDMA_PAdr, _ulDmaPciBusAddr);
    
    // ѥ᡼ꤵ줿DMA⡼ɤDMAξ硢DMAPEB륢ɥ쥹PCI-DMA륢ɥ쥹쥸˥饤
    if (pIoParameter->ulDmaMode == EIOVDMANEW)
        PebRegPut(REG_PDMA_LAdr, MSK_PDMA_LAdr, _ulDmaPebMemAddr);
    
    // DMAžPCI-DMAȥ쥸˥饤
    PebRegPut(REG_PDMA_Count, MSK_PDMA_Count, _ulDmaSendSize);
    
    // PCI-DMA쥸ͤν
    ulPDMACtl = 0;
    
    // ѥ᡼ꤵ줿DMAפDMAξ
    if (pIoParameter->ulDmaType == EIOVDMAIMAGE)
    {
        // PCI-DMA쥸ͤDMAIMGå
        ulPDMACtl |= BIT_DMAIMG;
        
        // ѥ᡼ꤵ줿DMA⡼ɤDMAξ硢PCI-DMA쥸ͤDMAFIMGå
        if (pIoParameter->ulDmaMode == EIOVDMANEW)
            ulPDMACtl |= BIT_DMAFIMG;
        
        // ѥ᡼ꤵ줿ϣ饤ǿΰ裱饤ǿ쥸˥饤
        PebRegPut(REG_Img_ILPix, MSK_Img_ILPix, pIoParameter->ulImgILPix);
        
        // ѥ᡼ꤵ줿ϥե졼ǿϥե졼ǿ쥸˥饤
        PebRegPut(REG_Img_IHPix, MSK_Img_IHPix, pIoParameter->ulImgIHPix);
    }
    
    // ѥ᡼ꤵ줿DMAžM/BPEBξ硢PCI-DMA쥸ͤDMADIRå
    if (pIoParameter->ulDmaDir == EIOVDMAREAD)
        ulPDMACtl |= BIT_DMADIR;
    
    // PCI-DMA쥸ͤDMASTRTå
    ulPDMACtl |= BIT_DMASTRT;
    
    // INTAޥ쥸PDMAINTMꥢ
    PebRegBitClr(REG_Int_Msk, BIT_PDMAINTM);
    
    // PCI-DMA쥸ͤPCI-DMA쥸˥饤
    PebRegPut(REG_PDMA_Ctl, MSK_PDMA_Ctl, ulPDMACtl);
    
    // ǥХ֤DMA˰ܹ
    _iDevOpeStat = EIOVDEVDMA;
    
    // ｪλ
    iResult = 0;
    
end:
    // λ
    #ifdef _DEBUG
    printk("%s: IoctlOpeDma: OUT(%d)\n", PRN_DEV_NAME, iResult);
    #endif
    return (iResult);
}

/*==========================================================================*
 *
 *  DMA߽
 *
 *==========================================================================*
 *
 *εǽ
 *  IRQߥϥɥ餫ƤФؿ
 *  DMAγ߽Ԥ
 *
 *η
 *  void IrqOpeDma(void);
 *
 *͡
 *  ʤ
 *
 *ա
 *
 *==========================================================================*/
static void IrqOpeDma(void)
{
    unsigned long ulPDMACtl;
    
    // 
    #ifdef _DEBUG
    printk("%s: IrqOpeDma: IN()\n", PRN_DEV_NAME);
    #endif
    
    // PCI-DMA쥸Υ꡼
    ulPDMACtl = PebRegGet(REG_PDMA_Ctl, MSK_PDMA_Ctl);
    
    // PCI-DMA쥸ͤM/BPEBξ硢DMAڡΥ꡼
    if (ulPDMACtl & BIT_DMADIR)
        _ulDmaSendSize = DmaPageRead(_ulDmaDevBuffAddr, _ulDmaSendSize);
    
    // DMAѥǥХХåեեåȥɥ쥹ι
    _ulDmaDevBuffAddr += _ulDmaSendSize;
    
    // DMAPEB륢ɥ쥹ι
    _ulDmaPebMemAddr += _ulDmaSendSize;
    
    // DMAžѤߥι
    _ulDmaSentSize += _ulDmaSendSize;
    
    // DMA³
    if (_ulDmaSentSize < _ulDmaTotalSize)
    {
        // DMAžλ
        _ulDmaSendSize = _ulDmaTotalSize - _ulDmaSentSize;
        if (_ulDmaSendSize > (unsigned long)_uDmaBuffSize)
            _ulDmaSendSize = (unsigned long)_uDmaBuffSize;
        
        // PCI-DMA쥸ͤM/BPEBξ硢DMAڡΥ饤
        if (!(ulPDMACtl & BIT_DMADIR))
            _ulDmaSendSize = DmaPageWrite(_ulDmaDevBuffAddr, _ulDmaSendSize);
        
        // DMAPCIХɥ쥹PCI-DMAPCIɥ쥹쥸˥饤
        PebRegPut(REG_PDMA_PAdr, MSK_PDMA_PAdr, _ulDmaPciBusAddr);
        
        // PCI-DMA쥸ͤ̾DMAξ硢DMAPEB륢ɥ쥹PCI-DMA륢ɥ쥹쥸˥饤
        if (!(ulPDMACtl & BIT_DMAIMG))
            PebRegPut(REG_PDMA_LAdr, MSK_PDMA_LAdr, _ulDmaPebMemAddr);
        
        // DMAžPCI-DMAȥ쥸˥饤
        PebRegPut(REG_PDMA_Count, MSK_PDMA_Count, _ulDmaSendSize);
        
        // PCI-DMA쥸ͤDMAFIMGꥢ
        ulPDMACtl &= ~BIT_DMAFIMG;
        
        // PCI-DMA쥸ͤDMASTRTå
        ulPDMACtl |= BIT_DMASTRT;
        
        // INTAޥ쥸PDMAINTMꥢ
        PebRegBitClr(REG_Int_Msk, BIT_PDMAINTM);
        
        // PCI-DMA쥸ͤPCI-DMA쥸˥饤
        PebRegPut(REG_PDMA_Ctl, MSK_PDMA_Ctl, ulPDMACtl);
    }
    
    // DMAλ
    else
    {
        // ǥХ֤Ԥ˰ܹ
        _iDevOpeStat = EIOVDEVIDLE;
    }
    
    // λ
    #ifdef _DEBUG
    printk("%s: IrqOpeDma: OUT()\n", PRN_DEV_NAME);
    #endif
    return;
}

/*==========================================================================*
 *
 *  ܡ
 *
 *==========================================================================*
 *
 *εǽ
 *  I/Oȥ᥽åɤƤФؿ
 *  I/Oѥ᡼򸵤˥ܡ¹Ԥ롣
 *
 *η
 *  int IoctlOpeBrdr(
 *      EIOPOPEBRDR *pIoParameter   // [I] I/Oѥ᡼
 *  );
 *
 *͡
 *  ｪλ        : 0
 *  ꥽  : -EBUSY
 *
 *ա
 *  ǥХ֤Ԥʳξϥӥ
 *
 *==========================================================================*/
static int IoctlOpeBrdr(EIOPOPEBRDR *pIoParameter)
{
    int iResult = -EBUSY;
    
    // 
    #ifdef _DEBUG
    printk("%s: IoctlOpeBrdr: IN(%p)\n", PRN_DEV_NAME, pIoParameter);
    #endif
    
    // ǥХ֤Ԥʳξϥ꥽
    if (_iDevOpeStat != EIOVDEVIDLE)
        goto end;
    
    #ifdef _DEBUG
    printk("%s: pIoParameter->ulBrdrDens    = %08lX\n", PRN_DEV_NAME, pIoParameter->ulBrdrDens);
    printk("%s: pIoParameter->ulBrdrTopAddr = %08lX\n", PRN_DEV_NAME, pIoParameter->ulBrdrTopAddr);
    printk("%s: pIoParameter->ulBrdrEndAddr = %08lX\n", PRN_DEV_NAME, pIoParameter->ulBrdrEndAddr);
    printk("%s: pIoParameter->ulImgOutAddr  = %08lX\n", PRN_DEV_NAME, pIoParameter->ulImgOutAddr);
    #endif
    
    // ѥ᡼ꤵ줿ܡǻ٤ܡǻ٥쥸˥饤
    PebRegPut(REG_Brdr_Dens, MSK_Brdr_Dens, pIoParameter->ulBrdrDens);
    
    // ѥ᡼ꤵ줿ܡϥɥ쥹ܡ쥸˥饤
    PebRegPut(REG_Brdr_Adr, MSK_Brdr_Adr, pIoParameter->ulBrdrTopAddr);
    
    // ѥ᡼ꤵ줿ܡλɥ쥹ܡ쥸˥饤
    PebRegPut(REG_Brdr_SPAdr, MSK_Brdr_SPAdr, pIoParameter->ulBrdrEndAddr);
    
    // ѥ᡼ꤵ줿ϲΰ襢ɥ쥹ΰ踶쥸˥饤
    PebRegPut(REG_Img_OutAdr, MSK_Img_OutAdr, pIoParameter->ulImgOutAddr);
    
    // INTAޥ쥸BRDRINTMꥢ
    PebRegBitClr(REG_Int_Msk, BIT_BRDRINTM);
    
    // ˥å쥸UCTLBRDRå
    PebRegBitSet(REG_Unit_Ctl, BIT_UCTLBRDR);
    
    // ǥХ֤ܡ˰ܹ
    _iDevOpeStat = EIOVDEVBRDR;
    
    // ｪλ
    iResult = 0;
    
end:
    // λ
    #ifdef _DEBUG
    printk("%s: IoctlOpeBrdr: OUT(%d)\n", PRN_DEV_NAME, iResult);
    #endif
    return (iResult);
}

/*==========================================================================*
 *
 *  ܡ߽
 *
 *==========================================================================*
 *
 *εǽ
 *  IRQߥϥɥ餫ƤФؿ
 *  ܡγ߽Ԥ
 *
 *η
 *  void IrqOpeBrdr(void);
 *
 *͡
 *  ʤ
 *
 *ա
 *
 *==========================================================================*/
static void IrqOpeBrdr(void)
{
    // 
    #ifdef _DEBUG
    printk("%s: IrqOpeBrdr: IN()\n", PRN_DEV_NAME);
    #endif
    
    // ǥХ֤Ԥ˰ܹ
    _iDevOpeStat = EIOVDEVIDLE;
    
    // λ
    #ifdef _DEBUG
    printk("%s: IrqOpeBrdr: OUT()\n", PRN_DEV_NAME);
    #endif
    return;
}

/*==========================================================================*
 *
 *  
 *
 *==========================================================================*
 *
 *εǽ
 *  I/Oȥ᥽åɤƤФؿ
 *  I/Oѥ᡼򸵤˲¹Ԥ롣
 *
 *η
 *  int IoctlOpeImg(
 *      EIOPOPEIMG *pIoParameter    // [I] I/Oѥ᡼
 *  );
 *
 *͡
 *  ｪλ        : 0
 *  ꥽  : -EBUSY
 *
 *ա
 *  ǥХ֤Ԥʳξϥӥ
 *
 *==========================================================================*/
static int IoctlOpeImg(EIOPOPEIMG *pIoParameter)
{
    int iResult = -EBUSY;
    unsigned long ulUnitCtl;
    unsigned int uIndex;
    
    // 
    #ifdef _DEBUG
    printk("%s: IoctlOpeImg: IN(%p)\n", PRN_DEV_NAME, pIoParameter);
    #endif
    
    // ǥХ֤Ԥʳξϥ꥽
    if (_iDevOpeStat != EIOVDEVIDLE)
        goto end;
    
    #ifdef _DEBUG
    printk("%s: pIoParameter->ulImgMode     = %lu\n",   PRN_DEV_NAME, pIoParameter->ulImgMode);
    printk("%s: pIoParameter->ulTrmMode     = %lu\n",   PRN_DEV_NAME, pIoParameter->ulTrmMode);
    printk("%s: pIoParameter->ulImgInAddr   = %08lX\n", PRN_DEV_NAME, pIoParameter->ulImgInAddr);
    printk("%s: pIoParameter->ulImgTmpAddr  = %08lX\n", PRN_DEV_NAME, pIoParameter->ulImgTmpAddr);
    printk("%s: pIoParameter->ulImgOutAddr  = %08lX\n", PRN_DEV_NAME, pIoParameter->ulImgOutAddr);
    printk("%s: pIoParameter->ulImgILPix    = %08lX\n", PRN_DEV_NAME, pIoParameter->ulImgILPix);
    printk("%s: pIoParameter->ulImgOLPix    = %08lX\n", PRN_DEV_NAME, pIoParameter->ulImgOLPix);
    printk("%s: pIoParameter->ulImgIFAddr   = %08lX\n", PRN_DEV_NAME, pIoParameter->ulImgIFAddr);
    printk("%s: pIoParameter->ulImgOFAddr   = %08lX\n", PRN_DEV_NAME, pIoParameter->ulImgOFAddr);
    printk("%s: pIoParameter->ulImgIHPix    = %08lX\n", PRN_DEV_NAME, pIoParameter->ulImgIHPix);
    printk("%s: pIoParameter->ulImgIVPix    = %08lX\n", PRN_DEV_NAME, pIoParameter->ulImgIVPix);
    printk("%s: pIoParameter->ulImgOHPix    = %08lX\n", PRN_DEV_NAME, pIoParameter->ulImgOHPix);
    printk("%s: pIoParameter->ulImgOVPix    = %08lX\n", PRN_DEV_NAME, pIoParameter->ulImgOVPix);
    printk("%s: pIoParameter->ulImgHRatio   = %08lX\n", PRN_DEV_NAME, pIoParameter->ulImgHRatio);
    printk("%s: pIoParameter->ulImgVRatio   = %08lX\n", PRN_DEV_NAME, pIoParameter->ulImgVRatio);
    printk("%s: pIoParameter->ulImgLayout   = %08lX\n", PRN_DEV_NAME, pIoParameter->ulImgLayout);
    printk("%s: pIoParameter->ulTrmPix      = %08lX\n", PRN_DEV_NAME, pIoParameter->ulTrmPix);
    printk("%s: pIoParameter->ulTrmDens     = %08lX\n", PRN_DEV_NAME, pIoParameter->ulTrmDens);
    for (uIndex = 0; uIndex < 256; uIndex ++)
    printk("%s: pIoParameter->ulHokanLUT[0] = %08lX\n", PRN_DEV_NAME, pIoParameter->ulHokanLUT[0][uIndex]);
    for (uIndex = 0; uIndex < 256; uIndex ++)
    printk("%s: pIoParameter->ulHokanLUT[1] = %08lX\n", PRN_DEV_NAME, pIoParameter->ulHokanLUT[1][uIndex]);
    for (uIndex = 0; uIndex < 256; uIndex ++)
    printk("%s: pIoParameter->ulHokanLUT[2] = %08lX\n", PRN_DEV_NAME, pIoParameter->ulHokanLUT[2][uIndex]);
    for (uIndex = 0; uIndex < 256; uIndex ++)
    printk("%s: pIoParameter->ulHokanLUT[3] = %08lX\n", PRN_DEV_NAME, pIoParameter->ulHokanLUT[3][uIndex]);
    #endif
    
    // ѥ᡼ꤵ줿ϲΰ襢ɥ쥹ΰ踶쥸˥饤
    PebRegPut(REG_Img_InAdr, MSK_Img_InAdr, pIoParameter->ulImgInAddr);
    
    // ѥ᡼ꤵ줿ֲǼɥ쥹ΰ踶쥸˥饤
    PebRegPut(REG_Img_TmpAdr, MSK_Img_TmpAdr, pIoParameter->ulImgTmpAddr);
    
    // ѥ᡼ꤵ줿ϲΰ襢ɥ쥹ΰ踶쥸˥饤
    PebRegPut(REG_Img_OutAdr, MSK_Img_OutAdr, pIoParameter->ulImgOutAddr);
    
    // ѥ᡼ꤵ줿ϣ饤ǿΰ裱饤ǿ쥸˥饤
    PebRegPut(REG_Img_ILPix, MSK_Img_ILPix, pIoParameter->ulImgILPix);
    
    // ѥ᡼ꤵ줿ϣ饤ǿΰ裱饤ǿ쥸˥饤
    PebRegPut(REG_Img_OLPix, MSK_Img_OLPix, pIoParameter->ulImgOLPix);
    
    // ѥ᡼ꤵ줿ϥե졼ॢɥ쥹ϥե졼ึ쥸˥饤
    PebRegPut(REG_Img_IFAdr, MSK_Img_IFAdr, pIoParameter->ulImgIFAddr);
    
    // ѥ᡼ꤵ줿ϥե졼ॢɥ쥹ϥե졼ึ쥸˥饤
    PebRegPut(REG_Img_OFAdr, MSK_Img_OFAdr, pIoParameter->ulImgOFAddr);
    
    // ѥ᡼ꤵ줿ϥե졼ǿϥե졼ǿ쥸˥饤
    PebRegPut(REG_Img_IHPix, MSK_Img_IHPix, pIoParameter->ulImgIHPix);
    
    // ѥ᡼ꤵ줿ϥե졼ǿϥե졼ǿ쥸˥饤
    PebRegPut(REG_Img_IVPix, MSK_Img_IVPix, pIoParameter->ulImgIVPix);
    
    // ѥ᡼ꤵ줿ϥե졼ǿϥե졼ǿ쥸˥饤
    PebRegPut(REG_Img_OHPix, MSK_Img_OHPix, pIoParameter->ulImgOHPix);
    
    // ѥ᡼ꤵ줿ϥե졼ǿϥե졼ǿ쥸˥饤
    PebRegPut(REG_Img_OVPix, MSK_Img_OVPix, pIoParameter->ulImgOVPix);
    
    // ѥ᡼ꤵ줿ΨΨ쥸˥饤
    PebRegPut(REG_Img_HRatio, MSK_Img_HRatio, pIoParameter->ulImgHRatio);
    
    // ѥ᡼ꤵ줿ΨΨ쥸˥饤
    PebRegPut(REG_Img_VRatio, MSK_Img_VRatio, pIoParameter->ulImgVRatio);
    
    // ѥ᡼ꤵ줿쥤ե졼쥤ȥ쥸˥饤
    PebRegPut(REG_Img_Layout, MSK_Img_Layout, pIoParameter->ulImgLayout);
    
    // ѥ᡼ꤵ줿ȥȥ쥸˥饤
    PebRegPut(REG_Trm_Pix, MSK_Trm_Pix, pIoParameter->ulTrmPix);
    
    // ѥ᡼ꤵ줿ȥǻ٤ȥǻ٥쥸˥饤
    PebRegPut(REG_Trm_Dens, MSK_Trm_Dens, pIoParameter->ulTrmDens);
    
    // ѥ᡼ꤵ줿ַ(w0)ַLUT(w0)˥饤
    for (uIndex = 0; uIndex < 256; uIndex ++)
        PebRegPut(REG_Hokan_LUT0 + (uIndex << 2), MSK_Hokan_LUT0, pIoParameter->ulHokanLUT[0][uIndex]);
    
    // ѥ᡼ꤵ줿ַ(w1)ַLUT(w1)˥饤
    for (uIndex = 0; uIndex < 256; uIndex ++)
        PebRegPut(REG_Hokan_LUT1 + (uIndex << 2), MSK_Hokan_LUT0, pIoParameter->ulHokanLUT[1][uIndex]);
    
    // ѥ᡼ꤵ줿ַ(w2)ַLUT(w2)˥饤
    for (uIndex = 0; uIndex < 256; uIndex ++)
        PebRegPut(REG_Hokan_LUT2 + (uIndex << 2), MSK_Hokan_LUT0, pIoParameter->ulHokanLUT[2][uIndex]);
    
    // ѥ᡼ꤵ줿ַ(w3)ַLUT(w3)˥饤
    for (uIndex = 0; uIndex < 256; uIndex ++)
        PebRegPut(REG_Hokan_LUT3 + (uIndex << 2), MSK_Hokan_LUT0, pIoParameter->ulHokanLUT[3][uIndex]);
    
    // ˥å쥸ͤν
    ulUnitCtl = 0;
    
    // ѥ᡼ꤵ줿⡼ɤ򸵤˥˥å쥸ͤUCTLIMGå
    if (pIoParameter->ulImgMode == EIOVIMGON)
        ulUnitCtl |= BIT_UCTLIMG;
    
    // ѥ᡼ꤵ줿ȥ⡼ɤ򸵤˥˥å쥸ͤUCTLTRMå
    if (pIoParameter->ulTrmMode == EIOVTRMON)
        ulUnitCtl |= BIT_UCTLTRM;
    
    // INTAޥ쥸IMGINTMꥢ
    PebRegBitClr(REG_Int_Msk, BIT_IMGINTM);
    
    // ˥å쥸ͤ˥å쥸˥饤
    PebRegPut(REG_Unit_Ctl, MSK_Unit_Ctl, ulUnitCtl);
    
    // ǥХ֤˰ܹ
    _iDevOpeStat = EIOVDEVIMG;
    
    // ｪλ
    iResult = 0;
    
end:
    // λ
    #ifdef _DEBUG
    printk("%s: IoctlOpeImg: OUT(%d)\n", PRN_DEV_NAME, iResult);
    #endif
    return (iResult);
}

/*==========================================================================*
 *
 *  ߽
 *
 *==========================================================================*
 *
 *εǽ
 *  IRQߥϥɥ餫ƤФؿ
 *  γ߽Ԥ
 *
 *η
 *  void IrqOpeImg(void);
 *
 *͡
 *  ʤ
 *
 *ա
 *
 *==========================================================================*/
static void IrqOpeImg(void)
{
    // 
    #ifdef _DEBUG
    printk("%s: IrqOpeImg: IN()\n", PRN_DEV_NAME);
    #endif
    
    // ǥХ֤Ԥ˰ܹ
    _iDevOpeStat = EIOVDEVIDLE;
    
    // λ
    #ifdef _DEBUG
    printk("%s: IrqOpeImg: OUT()\n", PRN_DEV_NAME);
    #endif
    return;
}

/*==========================================================================*
 *
 *  ʸ
 *
 *==========================================================================*
 *
 *εǽ
 *  I/Oȥ᥽åɤƤФؿ
 *  I/Oѥ᡼򸵤ʸ¹Ԥ롣
 *
 *η
 *  int IoctlOpeChr(
 *      EIOPOPECHR *pIoParameter    // [I] I/Oѥ᡼
 *  );
 *
 *͡
 *  ｪλ        : 0
 *  ꥽  : -EBUSY
 *
 *ա
 *  ǥХ֤Ԥʳξϥӥ
 *
 *==========================================================================*/
static int IoctlOpeChr(EIOPOPECHR *pIoParameter)
{
    int iResult = -EBUSY;
    unsigned long ulFontSize, ulChrCtl, ulChrCode;
    unsigned int uIndex;
    
    // 
    #ifdef _DEBUG
    printk("%s: IoctlOpeChr: IN(%p)\n", PRN_DEV_NAME, pIoParameter);
    #endif
    
    // ǥХ֤Ԥʳξϥ꥽
    if (_iDevOpeStat != EIOVDEVIDLE)
        goto end;
    
    #ifdef _DEBUG
    printk("%s: pIoParameter->ulFontAddr   = %08lX\n", PRN_DEV_NAME, pIoParameter->ulFontAddr);
    printk("%s: pIoParameter->ulFontByte   = %08lX\n", PRN_DEV_NAME, pIoParameter->ulFontByte);
    printk("%s: pIoParameter->ulFontHPix   = %08lX\n", PRN_DEV_NAME, pIoParameter->ulFontHPix);
    printk("%s: pIoParameter->ulFontWPix   = %08lX\n", PRN_DEV_NAME, pIoParameter->ulFontWPix);
    printk("%s: pIoParameter->ulCharDens   = %08lX\n", PRN_DEV_NAME, pIoParameter->ulCharDens);
    printk("%s: pIoParameter->ulCharAddr   = %08lX\n", PRN_DEV_NAME, pIoParameter->ulCharAddr);
    printk("%s: pIoParameter->ulCharByte   = %08lX\n", PRN_DEV_NAME, pIoParameter->ulCharByte);
    printk("%s: pIoParameter->ulCharLayout = %08lX\n", PRN_DEV_NAME, pIoParameter->ulCharLayout);
    for (uIndex = 0; uIndex < 256; uIndex ++)
    printk("%s: pIoParameter->ulCharCode   = %08lX\n", PRN_DEV_NAME, pIoParameter->ulCharCode[uIndex]);
    #endif
    
    // ѥ᡼ꤵ줿եȳϥɥ쥹եȥǡǼΰ踶쥸˥饤
    PebRegPut(REG_Font_Adr1, MSK_Font_Adr1, pIoParameter->ulFontAddr);
    
    // ѥ᡼ꤵ줿եȥХȿեȥǡͤ˥å
    ulFontSize = pIoParameter->ulFontByte;
    
    // ѥ᡼ꤵ줿եȽĲǿեȥǡͤ˥å
    ulFontSize <<= 8;
    ulFontSize |= pIoParameter->ulFontHPix;
    
    // ѥ᡼ꤵ줿եȲǿեȥǡͤ˥å
    ulFontSize <<= 8;
    ulFontSize |= pIoParameter->ulFontWPix;
    
    // եȥǡͤեȥǡ쥸˥饤
    PebRegPut(REG_Font_Size1, MSK_Font_Size1, ulFontSize);
    
    // ѥ᡼ꤵ줿ʸǻ٤ͤʸǻ٤ͥ쥸˥饤
    PebRegPut(REG_Chr_DensTh, MSK_Chr_DensTh, pIoParameter->ulCharDens);
    
    // ѥ᡼ꤵ줿ʸ󳫻ϥɥ쥹ʸ쥸˥饤
    PebRegPut(REG_Chr_Adr1, MSK_Chr_Adr1, pIoParameter->ulCharAddr);
    
    // ѥ᡼ꤵ줿ʸʸ쥸ͤ˥å
    ulChrCtl = pIoParameter->ulCharByte;
    
    // ѥ᡼ꤵ줿ʸ쥤Ȥʸ쥸ͤ˥å
    ulChrCtl <<= 8;
    ulChrCtl |= pIoParameter->ulCharLayout;
    
    // ʸ쥸ͤʸ쥸˥饤
    PebRegPut(REG_Chr_Ctl1, MSK_Chr_Ctl1, ulChrCtl);
    
    // ѥ᡼ꤵ줿ʸ󥳡ɤʸ󥳡ΰ˥饤
    for (uIndex = 0; uIndex < 256; uIndex += 2)
    {
        ((unsigned short *)&ulChrCode)[1] = (unsigned short)pIoParameter->ulCharCode[uIndex + 0];
        ((unsigned short *)&ulChrCode)[0] = (unsigned short)pIoParameter->ulCharCode[uIndex + 1];
        PebRegPut(REG_Chr_Code1 + (uIndex << 1), MSK_Chr_Code1, ulChrCode);
    }
    
    // INTAޥ쥸CHRINTMꥢ
    PebRegBitClr(REG_Int_Msk, BIT_CHRINTM);
    
    // ˥å쥸UCTLCHRå
    PebRegBitSet(REG_Unit_Ctl, BIT_UCTLCHR);
    
    // ǥХ֤ʸ˰ܹ
    _iDevOpeStat = EIOVDEVCHR;
    
    // ｪλ
    iResult = 0;
    
end:
    // λ
    #ifdef _DEBUG
    printk("%s: IoctlOpeChr: OUT(%d)\n", PRN_DEV_NAME, iResult);
    #endif
    return (iResult);
}

/*==========================================================================*
 *
 *  ʸ߽
 *
 *==========================================================================*
 *
 *εǽ
 *  IRQߥϥɥ餫ƤФؿ
 *  ʸγ߽Ԥ
 *
 *η
 *  void IrqOpeChr(void);
 *
 *͡
 *  ʤ
 *
 *ա
 *
 *==========================================================================*/
static void IrqOpeChr(void)
{
    // 
    #ifdef _DEBUG
    printk("%s: IrqOpeChr: IN()\n", PRN_DEV_NAME);
    #endif
    
    // ǥХ֤Ԥ˰ܹ
    _iDevOpeStat = EIOVDEVIDLE;
    
    // λ
    #ifdef _DEBUG
    printk("%s: IrqOpeChr: OUT()\n", PRN_DEV_NAME);
    #endif
    return;
}

/*==========================================================================*
 *
 *  ǻ٥ѥå
 *
 *==========================================================================*
 *
 *εǽ
 *  I/Oȥ᥽åɤƤФؿ
 *  I/Oѥ᡼򸵤ǻ٥ѥå¹Ԥ롣
 *
 *η
 *  int IoctlOpePtc(
 *      EIOPOPEPTC *pIoParameter    // [I] I/Oѥ᡼
 *  );
 *
 *͡
 *  ｪλ        : 0
 *  ꥽  : -EBUSY
 *
 *ա
 *  ǥХ֤Ԥʳξϥӥ
 *
 *==========================================================================*/
static int IoctlOpePtc(EIOPOPEPTC *pIoParameter)
{
    int iResult = -EBUSY;
    
    // 
    #ifdef _DEBUG
    printk("%s: IoctlOpePtc: IN(%p)\n", PRN_DEV_NAME, pIoParameter);
    #endif
    
    // ǥХ֤Ԥʳξϥ꥽
    if (_iDevOpeStat != EIOVDEVIDLE)
        goto end;
    
    #ifdef _DEBUG
    printk("%s: pIoParameter->ulPtcAddr = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPtcAddr);
    printk("%s: pIoParameter->ulPtcHPix = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPtcHPix);
    printk("%s: pIoParameter->ulPtcVPix = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPtcVPix);
    printk("%s: pIoParameter->ulPtcDens = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPtcDens);
    #endif
    
    // ѥ᡼ꤵ줿ѥåϥɥ쥹ǻ٥ѥå쥸˥饤
    PebRegPut(REG_Ptc_Adr, MSK_Ptc_Adr, pIoParameter->ulPtcAddr);
    
    // ѥ᡼ꤵ줿ѥåǿǻ٥ѥåǿ쥸˥饤
    PebRegPut(REG_Ptc_HPix, MSK_Ptc_HPix, pIoParameter->ulPtcHPix);
    
    // ѥ᡼ꤵ줿ѥåǿǻ٥ѥåǿ쥸˥饤
    PebRegPut(REG_Ptc_VPix, MSK_Ptc_VPix, pIoParameter->ulPtcVPix);
    
    // ѥ᡼ꤵ줿ѥåǻ٤ǻ٥ѥåǻ٥쥸˥饤
    PebRegPut(REG_Ptc_Dens, MSK_Ptc_Dens, pIoParameter->ulPtcDens);
    
    // INTAޥ쥸PTCINTMꥢ
    PebRegBitClr(REG_Int_Msk, BIT_PTCINTM);
    
    // ˥å쥸UCTLPTCå
    PebRegBitSet(REG_Unit_Ctl, BIT_UCTLPTC);
    
    // ǥХ֤ǻ٥ѥå˰ܹ
    _iDevOpeStat = EIOVDEVPTC;
    
    // ｪλ
    iResult = 0;
    
end:
    // λ
    #ifdef _DEBUG
    printk("%s: IoctlOpePtc: OUT(%d)\n", PRN_DEV_NAME, iResult);
    #endif
    return (iResult);
}

/*==========================================================================*
 *
 *  ǻ٥ѥå߽
 *
 *==========================================================================*
 *
 *εǽ
 *  IRQߥϥɥ餫ƤФؿ
 *  ǻ٥ѥåγ߽Ԥ
 *
 *η
 *  void IrqOpePtc(void);
 *
 *͡
 *  ʤ
 *
 *ա
 *
 *==========================================================================*/
static void IrqOpePtc(void)
{
    // 
    #ifdef _DEBUG
    printk("%s: IrqOpePtc: IN()\n", PRN_DEV_NAME);
    #endif
    
    // ǥХ֤Ԥ˰ܹ
    _iDevOpeStat = EIOVDEVIDLE;
    
    // λ
    #ifdef _DEBUG
    printk("%s: IrqOpePtc: OUT()\n", PRN_DEV_NAME);
    #endif
    return;
}

/*==========================================================================*
 *
 *  ץȽ
 *
 *==========================================================================*
 *
 *εǽ
 *  I/Oȥ᥽åɤƤФؿ
 *  I/Oѥ᡼򸵤˥ץȽ¹Ԥ롣
 *
 *η
 *  int IoctlOpePrnt(
 *      EIOPOPEPRNT *pIoParameter   // [I] I/Oѥ᡼
 *  );
 *
 *͡
 *  ｪλ        : 0
 *  ꥽  : -EBUSY
 *
 *ա
 *  ǥХ֤Ԥʳξϥӥ
 *
 *==========================================================================*/
static int IoctlOpePrnt(EIOPOPEPRNT *pIoParameter)
{
    int iResult = -EBUSY;
    unsigned int uIndex;
    
    // 
    #ifdef _DEBUG
    printk("%s: IoctlOpePrnt: IN(%p)\n", PRN_DEV_NAME, pIoParameter);
    #endif
    
    // ǥХ֤Ԥʳξϥ꥽
    if (_iDevOpeStat != EIOVDEVIDLE)
        goto end;
    
    #ifdef _DEBUG
    printk("%s: pIoParameter->ulBriHsync    = %08lX\n", PRN_DEV_NAME, pIoParameter->ulBriHsync);
    printk("%s: pIoParameter->ulTopHsync    = %08lX\n", PRN_DEV_NAME, pIoParameter->ulTopHsync);
    printk("%s: pIoParameter->ulEndHsync    = %08lX\n", PRN_DEV_NAME, pIoParameter->ulEndHsync);
    printk("%s: pIoParameter->ulTopHPix     = %08lX\n", PRN_DEV_NAME, pIoParameter->ulTopHPix);
    printk("%s: pIoParameter->ulEndHPix     = %08lX\n", PRN_DEV_NAME, pIoParameter->ulEndHPix);
    printk("%s: pIoParameter->ulLineHPix    = %08lX\n", PRN_DEV_NAME, pIoParameter->ulLineHPix);
    printk("%s: pIoParameter->ulTopVPix     = %08lX\n", PRN_DEV_NAME, pIoParameter->ulTopVPix);
    printk("%s: pIoParameter->ulEndVPix     = %08lX\n", PRN_DEV_NAME, pIoParameter->ulEndVPix);
    printk("%s: pIoParameter->ulPrnAddr     = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPrnAddr);
    printk("%s: pIoParameter->ulPrnLOPix    = %08lX\n", PRN_DEV_NAME, pIoParameter->ulPrnLOPix);
    printk("%s: pIoParameter->ulMuraMode    = %lu\n",   PRN_DEV_NAME, pIoParameter->ulMuraMode);
    printk("%s: pIoParameter->ulMuraSwitch  = %08lX\n", PRN_DEV_NAME, pIoParameter->ulMuraSwitch);
    printk("%s: pIoParameter->ulTopMuraPix  = %08lX\n", PRN_DEV_NAME, pIoParameter->ulTopMuraPix);
    printk("%s: pIoParameter->ulEndMuraPix  = %08lX\n", PRN_DEV_NAME, pIoParameter->ulEndMuraPix);
    printk("%s: pIoParameter->ulTopKotanPix = %08lX\n", PRN_DEV_NAME, pIoParameter->ulTopKotanPix);
    printk("%s: pIoParameter->ulTopUtanPix  = %08lX\n", PRN_DEV_NAME, pIoParameter->ulTopUtanPix);
    for (uIndex = 0; uIndex < 256; uIndex ++)
    printk("%s: pIoParameter->ulKoryoLUT    = %08lX\n", PRN_DEV_NAME, pIoParameter->ulKoryoLUT[uIndex]);
    for (uIndex = 0; uIndex < (6 * 64); uIndex ++)
    printk("%s: pIoParameter->ulMuraLUT[0]  = %08lX\n", PRN_DEV_NAME, pIoParameter->ulMuraLUT[0][uIndex]);
    for (uIndex = 0; uIndex < (6 * 64); uIndex ++)
    printk("%s: pIoParameter->ulMuraLUT[1]  = %08lX\n", PRN_DEV_NAME, pIoParameter->ulMuraLUT[1][uIndex]);
    for (uIndex = 0; uIndex < (6 * 64); uIndex ++)
    printk("%s: pIoParameter->ulMuraLUT[2]  = %08lX\n", PRN_DEV_NAME, pIoParameter->ulMuraLUT[2][uIndex]);
    for (uIndex = 0; uIndex < (6 * 64); uIndex ++)
    printk("%s: pIoParameter->ulMuraLUT[3]  = %08lX\n", PRN_DEV_NAME, pIoParameter->ulMuraLUT[3][uIndex]);
    for (uIndex = 0; uIndex < (6 * 64); uIndex ++)
    printk("%s: pIoParameter->ulMuraLUT[4]  = %08lX\n", PRN_DEV_NAME, pIoParameter->ulMuraLUT[4][uIndex]);
    for (uIndex = 0; uIndex < (6 * 64); uIndex ++)
    printk("%s: pIoParameter->ulMuraLUT[5]  = %08lX\n", PRN_DEV_NAME, pIoParameter->ulMuraLUT[5][uIndex]);
    for (uIndex = 0; uIndex < (6 * 64); uIndex ++)
    printk("%s: pIoParameter->ulMuraLUT[6]  = %08lX\n", PRN_DEV_NAME, pIoParameter->ulMuraLUT[6][uIndex]);
    for (uIndex = 0; uIndex < (6 * 64); uIndex ++)
    printk("%s: pIoParameter->ulMuraLUT[7]  = %08lX\n", PRN_DEV_NAME, pIoParameter->ulMuraLUT[7][uIndex]);
    for (uIndex = 0; uIndex < (6 * 64); uIndex ++)
    printk("%s: pIoParameter->ulMuraLUT[8]  = %08lX\n", PRN_DEV_NAME, pIoParameter->ulMuraLUT[8][uIndex]);
    for (uIndex = 0; uIndex < (6 * 64); uIndex ++)
    printk("%s: pIoParameter->ulMuraLUT[9]  = %08lX\n", PRN_DEV_NAME, pIoParameter->ulMuraLUT[9][uIndex]);
    for (uIndex = 0; uIndex < (6 * 64); uIndex ++)
    printk("%s: pIoParameter->ulMuraLUT[10] = %08lX\n", PRN_DEV_NAME, pIoParameter->ulMuraLUT[10][uIndex]);
    for (uIndex = 0; uIndex < (6 * 64); uIndex ++)
    printk("%s: pIoParameter->ulMuraLUT[11] = %08lX\n", PRN_DEV_NAME, pIoParameter->ulMuraLUT[11][uIndex]);
    for (uIndex = 0; uIndex < (6 * 64); uIndex ++)
    printk("%s: pIoParameter->ulMuraLUT[12] = %08lX\n", PRN_DEV_NAME, pIoParameter->ulMuraLUT[12][uIndex]);
    for (uIndex = 0; uIndex < (6 * 64); uIndex ++)
    printk("%s: pIoParameter->ulMuraLUT[13] = %08lX\n", PRN_DEV_NAME, pIoParameter->ulMuraLUT[13][uIndex]);
    for (uIndex = 0; uIndex < (6 * 64); uIndex ++)
    printk("%s: pIoParameter->ulMuraLUT[14] = %08lX\n", PRN_DEV_NAME, pIoParameter->ulMuraLUT[14][uIndex]);
    for (uIndex = 0; uIndex < 64; uIndex ++)
    printk("%s: pIoParameter->ulSentanLUT   = %08lX\n", PRN_DEV_NAME, pIoParameter->ulSentanLUT[uIndex]);
    for (uIndex = 0; uIndex < 32; uIndex ++)
    printk("%s: pIoParameter->ulKotanLUT    = %08lX\n", PRN_DEV_NAME, pIoParameter->ulKotanLUT[uIndex]);
    for (uIndex = 0; uIndex < 16; uIndex ++)
    printk("%s: pIoParameter->ulSayutanLUT  = %08lX\n", PRN_DEV_NAME, pIoParameter->ulSayutanLUT[uIndex]);
    for (uIndex = 0; uIndex < 6; uIndex ++)
    printk("%s: pIoParameter->ulFFReqData   = %08lX\n", PRN_DEV_NAME, pIoParameter->ulFFReqData[uIndex]);
    printk("%s: pIoParameter->ulFLineData   = %08lX\n", PRN_DEV_NAME, pIoParameter->ulFLineData[0]);
    printk("%s: pIoParameter->ulFFMod       = %08lX\n", PRN_DEV_NAME, pIoParameter->ulFFMod);
    printk("%s: pIoParameter->ulFDelayRatio = %08lX\n", PRN_DEV_NAME, pIoParameter->ulFDelayRatio);
    printk("%s: pIoParameter->ulFCut        = %08lX\n", PRN_DEV_NAME, pIoParameter->ulFCut);
    printk("%s: pIoParameter->ulFSel1stAdj  = %08lX\n", PRN_DEV_NAME, pIoParameter->ulFSel1stAdj);
    printk("%s: pIoParameter->ulFSelAdj     = %08lX\n", PRN_DEV_NAME, pIoParameter->ulFSelAdj);
    printk("%s: pIoParameter->ulLSStart     = %08lX\n", PRN_DEV_NAME, pIoParameter->ulLSStart);
    printk("%s: pIoParameter->ulLSWidth     = %08lX\n", PRN_DEV_NAME, pIoParameter->ulLSWidth);
    #endif
    
    // ѥ᡼ꤵ줿HSYNCи̤Hsyncи̥쥸˥饤
    PebRegPut(REG_Bri_Hsync, MSK_Bri_Hsync, pIoParameter->ulBriHsync);
    
    // ѥ᡼ꤵ줿HSYNCгϰ֤Hsyncгϰ֥쥸˥饤
    PebRegPut(REG_Start_Hsync, MSK_Start_Hsync, pIoParameter->ulTopHsync);
    
    // ѥ᡼ꤵ줿HSYNCнλ֤Hsyncнλ֥쥸˥饤
    PebRegPut(REG_Stop_Hsync, MSK_Stop_Hsync, pIoParameter->ulEndHsync);
    
    // ѥ᡼ꤵ줿ǡϳϰ֤ǡϳϰ֥쥸˥饤
    PebRegPut(REG_Start_HPix, MSK_Start_HPix, pIoParameter->ulTopHPix);
    
    // ѥ᡼ꤵ줿ǡϽλ֤ǡϽλ֥쥸˥饤
    PebRegPut(REG_Stop_HPix, MSK_Stop_HPix, pIoParameter->ulEndHPix);
    
    // ѥ᡼ꤵ줿ǡϲǿ饤ϲǿ쥸˥饤
    PebRegPut(REG_Line_HPix, MSK_Line_HPix, pIoParameter->ulLineHPix);
    
    // ѥ᡼ꤵ줿ǡϳϰ֤ǡϳϰ֥쥸˥饤
    PebRegPut(REG_Start_VPix, MSK_Start_VPix, pIoParameter->ulTopVPix);
    
    // ѥ᡼ꤵ줿ǡϽλ֤ǡϽλ֥쥸˥饤
    PebRegPut(REG_Stop_VPix, MSK_Stop_VPix, pIoParameter->ulEndVPix);
    
    // ѥ᡼ꤵ줿ץȳϥɥ쥹ץȸ쥸˥饤
    PebRegPut(REG_Prn_Adr, MSK_Prn_Adr, pIoParameter->ulPrnAddr);
    
    // ѥ᡼ꤵ줿ץȣ饤ǿץȥ饤󥪥եåȥ쥸˥饤
    PebRegPut(REG_Prn_LOPix, MSK_Prn_LOPix, pIoParameter->ulPrnLOPix);
    
    // ѥ᡼ꤵ줿⡼ɤƥȥ⡼ɥ쥸TMDMPTå
    if (pIoParameter->ulMuraMode == EIOVLUTDEFAULT)
        PebRegBitClr(REG_Test_Mode, BIT_TMDMPT);
    else
        PebRegBitSet(REG_Test_Mode, BIT_TMDMPT);
    
    // ѥ᡼ꤵ줿عԿعԿ쥸˥饤
    PebRegPut(REG_Mura_Switch, MSK_Mura_Switch, pIoParameter->ulMuraSwitch);
    
    // ѥ᡼ꤵ줿ϲǰ֤ϰ֥쥸˥饤
    PebRegPut(REG_Start_MuraLUT, MSK_Start_MuraLUT, pIoParameter->ulTopMuraPix);
    
    // ѥ᡼ꤵ줿λǰ֤λ֥쥸˥饤
    PebRegPut(REG_Stop_MuraLUT, MSK_Stop_MuraLUT, pIoParameter->ulEndMuraPix);
    
    // ѥ᡼ꤵ줿üϲǰ֤üϰ֥쥸˥饤
    PebRegPut(REG_Start_KotanLUT, MSK_Start_KotanLUT, pIoParameter->ulTopKotanPix);
    
    // ѥ᡼ꤵ줿üϲǰ֤üϰ֥쥸˥饤
    PebRegPut(REG_Start_UtanLUT, MSK_Start_UtanLUT, pIoParameter->ulTopUtanPix);
    
    // ѥ᡼ꤵ줿ǻ١ѴLUTǻ١ѴLUT˥饤
    for (uIndex = 0; uIndex < 256; uIndex ++)
        PebRegPut(REG_Koryo_LUT + (uIndex << 2), MSK_Koryo_LUT, pIoParameter->ulKoryoLUT[uIndex]);
    
    // ѥ᡼ꤵ줿쥸˥饤
    for (uIndex = 0; uIndex < (6 * 64); uIndex ++)
        PebRegPut(REG_Mura_LUT0_1 + (uIndex << 2), MSK_Mura_LUT0_1, pIoParameter->ulMuraLUT[0][uIndex]);
    
    // ѥ᡼ꤵ줿쥸˥饤
    for (uIndex = 0; uIndex < (6 * 64); uIndex ++)
        PebRegPut(REG_Mura_LUT0_2 + (uIndex << 2), MSK_Mura_LUT0_2, pIoParameter->ulMuraLUT[1][uIndex]);
    
    // ѥ᡼ꤵ줿쥸˥饤
    for (uIndex = 0; uIndex < (6 * 64); uIndex ++)
        PebRegPut(REG_Mura_LUT0_3 + (uIndex << 2), MSK_Mura_LUT0_3, pIoParameter->ulMuraLUT[2][uIndex]);
    
    // ѥ᡼ꤵ줿쥸˥饤
    for (uIndex = 0; uIndex < (6 * 64); uIndex ++)
        PebRegPut(REG_Mura_LUT0_4 + (uIndex << 2), MSK_Mura_LUT0_4, pIoParameter->ulMuraLUT[3][uIndex]);
    
    // ѥ᡼ꤵ줿쥸˥饤
    for (uIndex = 0; uIndex < (6 * 64); uIndex ++)
        PebRegPut(REG_Mura_LUT0_5 + (uIndex << 2), MSK_Mura_LUT0_5, pIoParameter->ulMuraLUT[4][uIndex]);
    
    // ѥ᡼ꤵ줿쥸˥饤
    for (uIndex = 0; uIndex < (6 * 64); uIndex ++)
        PebRegPut(REG_Mura_LUT0_6 + (uIndex << 2), MSK_Mura_LUT0_6, pIoParameter->ulMuraLUT[5][uIndex]);
    
    // ѥ᡼ꤵ줿쥸˥饤
    for (uIndex = 0; uIndex < (6 * 64); uIndex ++)
        PebRegPut(REG_Mura_LUT0_7 + (uIndex << 2), MSK_Mura_LUT0_7, pIoParameter->ulMuraLUT[6][uIndex]);
    
    // ѥ᡼ꤵ줿쥸˥饤
    for (uIndex = 0; uIndex < (6 * 64); uIndex ++)
        PebRegPut(REG_Mura_LUT0_8 + (uIndex << 2), MSK_Mura_LUT0_8, pIoParameter->ulMuraLUT[7][uIndex]);
    
    // ѥ᡼ꤵ줿쥸˥饤
    for (uIndex = 0; uIndex < (6 * 64); uIndex ++)
        PebRegPut(REG_Mura_LUT0_9 + (uIndex << 2), MSK_Mura_LUT0_9, pIoParameter->ulMuraLUT[8][uIndex]);
    
    // ѥ᡼ꤵ줿쥸˥饤
    for (uIndex = 0; uIndex < (6 * 64); uIndex ++)
        PebRegPut(REG_Mura_LUT0_10 + (uIndex << 2), MSK_Mura_LUT0_10, pIoParameter->ulMuraLUT[9][uIndex]);
    
    // ѥ᡼ꤵ줿쥸˥饤
    for (uIndex = 0; uIndex < (6 * 64); uIndex ++)
        PebRegPut(REG_Mura_LUT0_11 + (uIndex << 2), MSK_Mura_LUT0_11, pIoParameter->ulMuraLUT[10][uIndex]);
    
    // ѥ᡼ꤵ줿쥸˥饤
    for (uIndex = 0; uIndex < (6 * 64); uIndex ++)
        PebRegPut(REG_Mura_LUT0_12 + (uIndex << 2), MSK_Mura_LUT0_12, pIoParameter->ulMuraLUT[11][uIndex]);
    
    // ѥ᡼ꤵ줿쥸˥饤
    for (uIndex = 0; uIndex < (6 * 64); uIndex ++)
        PebRegPut(REG_Mura_LUT0_13 + (uIndex << 2), MSK_Mura_LUT0_13, pIoParameter->ulMuraLUT[12][uIndex]);
    
    // ѥ᡼ꤵ줿쥸˥饤
    for (uIndex = 0; uIndex < (6 * 64); uIndex ++)
        PebRegPut(REG_Mura_LUT0_14 + (uIndex << 2), MSK_Mura_LUT0_14, pIoParameter->ulMuraLUT[13][uIndex]);
    
    // ѥ᡼ꤵ줿쥸˥饤
    for (uIndex = 0; uIndex < (6 * 64); uIndex ++)
        PebRegPut(REG_Mura_LUT0_15 + (uIndex << 2), MSK_Mura_LUT0_15, pIoParameter->ulMuraLUT[14][uIndex]);
    
    // ѥ᡼ꤵ줿üLUTüLUT˥饤
    for (uIndex = 0; uIndex < 64; uIndex ++)
        PebRegPut(REG_Sentan_LUT + (uIndex << 2), MSK_Sentan_LUT, pIoParameter->ulSentanLUT[uIndex]);
    
    // ѥ᡼ꤵ줿üLUTüLUT˥饤
    for (uIndex = 0; uIndex < 32; uIndex ++)
        PebRegPut(REG_Kotan_LUT + (uIndex << 2), MSK_Kotan_LUT, pIoParameter->ulKotanLUT[uIndex]);
    
    // ѥ᡼ꤵ줿üLUT򺸱üLUT˥饤
    for (uIndex = 0; uIndex < 16; uIndex ++)
        PebRegPut(REG_Sayutan_LUT + (uIndex << 2), MSK_Sayutan_LUT, pIoParameter->ulSayutanLUT[uIndex]);
    
    // ѥ᡼ꤵ줿ȿĴǡȿĴǡ쥸˥饤
    for (uIndex = 0; uIndex < 6; uIndex ++)
    {
        PebRegPut(REG_FFREQ_DATA0_1 + (uIndex << 3), MSK_FFREQ_DATA0_1, pIoParameter->ulFFReqData[uIndex]);
        PebRegPut(REG_FFREQ_DATA0_2 + (uIndex << 3), MSK_FFREQ_DATA0_2, pIoParameter->ulFFReqData[uIndex] >> 8);
    }
    
    // ѥ᡼ꤵ줿쥸ȥ󥵴ֵΥ쥸ȥ󥵴ֵΥ쥸˥饤
    for (uIndex = 0; uIndex < 1; uIndex ++)
    {
        PebRegPut(REG_FLINE_DATA0_1 + (uIndex << 3), MSK_FLINE_DATA0_1, pIoParameter->ulFLineData[uIndex]);
        PebRegPut(REG_FLINE_DATA0_2 + (uIndex << 3), MSK_FLINE_DATA0_2, pIoParameter->ulFLineData[uIndex] >> 8);
    }
    
    // ѥ᡼ꤵ줿ȿĴ򸵤˼ȿĴ쥸FFMENå
    if (pIoParameter->ulFFMod == EIOVFFMODOFF)
        PebRegBitClr(REG_FF_MOD, BIT_FFMEN);
    else
        PebRegBitSet(REG_FF_MOD, BIT_FFMEN);
    
    // ѥ᡼ꤵ줿Ĵǥ쥤ʿĴǥ쥤ʿ쥸˥饤
    PebRegPut(REG_FDELAY_RATIO, MSK_FDELAY_RATIO, pIoParameter->ulFDelayRatio);
    
    // ѥ᡼ꤵ줿Ĵǥ쥤Ĵǥ쥤쥸˥饤
    PebRegPut(REG_FCUT, MSK_FCUT, pIoParameter->ulFCut);
    
    // ѥ᡼ꤵ줿ȿ쥯Ƚ̥㥹Ȥȿ쥯Ƚ̥㥹Ȥ˥饤
    PebRegPut(REG_FSEL1ST_ADJ, MSK_FSEL1ST_ADJ, pIoParameter->ulFSel1stAdj);
    
    // ѥ᡼ꤵ줿ȿ쥯ٱ䥢㥹Ȥȿ쥯ٱ䥢㥹ȥ쥸˥饤
    PebRegPut(REG_FSEL_ADJ, MSK_FSEL_ADJ, pIoParameter->ulFSelAdj);
    
    // ѥ᡼ꤵ줿LSYNCϥߥ󥰤LSYNCϥߥ󥰥쥸˥饤
    PebRegPut(REG_LS_START, MSK_LS_START, pIoParameter->ulLSStart);
    
    // ѥ᡼ꤵ줿LSYNCLSYNC쥸˥饤
    PebRegPut(REG_LS_WIDTH, MSK_LS_WIDTH, pIoParameter->ulLSWidth);
    
    // ץȥ顼֤ν
    _uPebPrnStat = 0;
    
    // Ϫå쥸ꥢ
    PebRegPut(REG_Exp_Latch, MSK_Exp_Latch, 0);
    
    // INTAޥ쥸PRNTINTMꥢ
    PebRegBitClr(REG_Int_Msk, BIT_PRNTINTM);
    
    // ץ쥸PCTLPENå
    PebRegBitSet(REG_Prn_Ctl, BIT_PCTLPEN);
    
    // ǥХ֤ץȽ˰ܹ
    _iDevOpeStat = EIOVDEVPRNT;
    
    // ｪλ
    iResult = 0;
    
end:
    // λ
    #ifdef _DEBUG
    printk("%s: IoctlOpePrnt: OUT(%d)\n", PRN_DEV_NAME, iResult);
    #endif
    return (iResult);
}

/*==========================================================================*
 *
 *  ץȳ߽
 *
 *==========================================================================*
 *
 *εǽ
 *  IRQߥϥɥ餫ƤФؿ
 *  ץȽγ߽Ԥ
 *
 *η
 *  void IrqOpePrnt(void);
 *
 *͡
 *  ʤ
 *
 *ա
 *
 *==========================================================================*/
static void IrqOpePrnt(void)
{
    unsigned long ulExpLatch, ulPrtState;
    
    // 
    #ifdef _DEBUG
    printk("%s: IrqOpePrnt: IN()\n", PRN_DEV_NAME);
    #endif
    
    // ץ쥸PCTLLDONꥢ
    PebRegBitClr(REG_Prn_Ctl, BIT_PCTLLDON);
    
    // Ϫå쥸Υ꡼
    ulExpLatch = PebRegGet(REG_Exp_Latch, MSK_Exp_Latch);
    
    // ץȥơ쥸Υ꡼
    ulPrtState = PebRegGet(REG_Prt_State, MSK_Prt_State);
    
    // ץȥơ쥸ͤHSYNCॢȤξ硢HSYNCॢȯ
    if ((ulPrtState & BIT_PRSE) == PRSE_HSNC)
        _uPebPrnStat |= EIOBPRNHSNCERR;
    
    // Ϫå쥸̸ͤΥ顼ξ硢̸Υ顼ȯ
    if (!(ulExpLatch & BIT_EILDETP))
        _uPebPrnStat |= EIOBPRNDETPERR;
    
    // Ϫå쥸ͤѥƥ顼ξ硢ѥƥ顼ȯ
    if (ulExpLatch & BIT_EILPRTE)
        _uPebPrnStat |= EIOBPRNPRTYERR;
    
    // ץȽｪλ硢Ϫå쥸ꥢ
    if (!_uPebPrnStat)
        PebRegPut(REG_Exp_Latch, MSK_Exp_Latch, 0);
    
    // ǥХ֤Ԥ˰ܹ
    _iDevOpeStat = EIOVDEVIDLE;
    
    // λ
    #ifdef _DEBUG
    printk("%s: IrqOpePrnt: OUT()\n", PRN_DEV_NAME);
    #endif
    return;
}

/*==========================================================================*
 *
 *  PEBꥻåȽ
 *
 *==========================================================================*
 *
 *εǽ
 *  I/Oȥ᥽åɤƤФؿ
 *  I/Oѥ᡼򸵤PEBꥻåȤ롣
 *
 *η
 *  int IoctlPebReset(
 *      EIOPPEBRESET *pIoParameter  // [I] I/Oѥ᡼
 *  );
 *
 *͡
 *  ｪλ        : 0
 *  ꥽  : -EBUSY
 *
 *ա
 *  ǥХ֤ԲĤξϥӥ
 *
 *==========================================================================*/
static int IoctlPebReset(EIOPPEBRESET *pIoParameter)
{
    int iResult = -EBUSY;
    long lResetWatchTime, lResetBaseTime, lResetNowTime;
    struct timeval tvNow;
    
    // 
    #ifdef _DEBUG
    printk("%s: IoctlPebReset: IN(%p)\n", PRN_DEV_NAME, pIoParameter);
    #endif
    
    // ǥХ֤ԲĤξϥ꥽
    if (_iDevOpeStat == EIOVDEVUNAVAIL)
        goto end;
    
    #ifdef _DEBUG
    printk("%s: pIoParameter->ulResetWatchTime = %lu\n", PRN_DEV_NAME, pIoParameter->ulResetWatchTime);
    #endif
    
    // ѥ᡼ꤵ줿ꥻåȳǧԤ(ms)ꥻåȳǧԤ(us)
    lResetWatchTime = pIoParameter->ulResetWatchTime * 1000;
    
    // INTAޥ쥸å
    PebRegPut(REG_Int_Msk, MSK_Int_Msk, ~0);
    
    // INTAװ쥸ꥢ
    PebRegPut(REG_Int_Req, MSK_Int_Req, 0);
    
    // PCI-DMA쥸DMASTOPå
    PebRegBitSet(REG_PDMA_Ctl, BIT_DMASTOP);
    
    // ꥻåȥ쥸LRSTå
    PebRegBitSet(REG_Local_Rst, BIT_LRST);
    
    // ߻μ
    do_gettimeofday(&tvNow);
    lResetBaseTime = tvNow.tv_usec;
    
    // ꥻåȳǧΤᡢʲν򷫤֤
    while (PebRegGet(REG_Local_Rst, MSK_Local_Rst))
    {
        do_gettimeofday(&tvNow);
        lResetNowTime = tvNow.tv_usec;
        if (lResetNowTime < lResetBaseTime)
            lResetNowTime += 1000000;
        if ((lResetNowTime - lResetBaseTime) > lResetWatchTime)
            break;
    }
    
    // Ϫå쥸ꥢ
    PebRegPut(REG_Exp_Latch, MSK_Exp_Latch, 0);
    
    // FLASHߵĥ쥸FLWꥢ
    PebRegBitClr(REG_FL_Write, BIT_FLW);
    
    // DMAžȡ륵ν
    _ulDmaTotalSize = 0;
    
    // ǥХХåեǡν
    _uDevDataLen = 0;
    
    // ץȥ顼֤ν
    _uPebPrnStat = 0;
    
    // ǥХ֤Ԥ˰ܹ
    _iDevOpeStat = EIOVDEVIDLE;
    
    // ｪλ
    iResult = 0;
    
end:
    // λ
    #ifdef _DEBUG
    printk("%s: IoctlPebReset: OUT(%d)\n", PRN_DEV_NAME, iResult);
    #endif
    return (iResult);
}

/*==========================================================================*
 *
 *  FLASHõ
 *
 *==========================================================================*
 *
 *εǽ
 *  I/Oȥ᥽åɤƤФؿ
 *  I/Oѥ᡼򸵤FLASHõ롣
 *
 *η
 *  int IoctlDelFlash(
 *      EIOPDELFLASH *pIoParameter  // [I] I/Oѥ᡼
 *  );
 *
 *͡
 *  ｪλ        : 0
 *  ꥽  : -EBUSY
 *
 *ա
 *  ǥХ֤Ԥʳξϥӥ
 *  FLASHϡFPGAե졼ΰ裱Хååѡ
 *  FPGAե졼ΰ裲򹹿ѤȤƹ롣
 *  FPGAե졼ΰ裱Ӥɤ߹ѤȤ뤿ᡢ
 *  õ륻ɬŪFPGAե졼ΰ裲Ȥʤ롣
 *
 *==========================================================================*/
static int IoctlDelFlash(EIOPDELFLASH *pIoParameter)
{
    int iResult = -EBUSY;
    static unsigned long ulSectorAddr[] = {
        FLM_SA16, 
        FLM_SA17, 
        FLM_SA18, 
        FLM_SA19, 
        FLM_SA20, 
        FLM_SA21, 
        FLM_SA22, 
        FLM_SA23, 
        FLM_SA24, 
        FLM_SA25, 
        FLM_SA26, 
        FLM_SA27, 
        FLM_SA28, 
        FLM_SA29, 
        FLM_SA30, 
        FLM_SA31, 
        FLM_SA32, 
        FLM_SA33, 
        FLM_SA34, 
        (unsigned long)-1, 
    };
    unsigned long *pulFlashMemAddr;
    long lEraseWatchTime, lEraseBaseTime, lEraseNowTime;
    struct timeval tvNow;
    int iPoint;
    
    // 
    #ifdef _DEBUG
    printk("%s: IoctlDelFlash: IN(%p)\n", PRN_DEV_NAME, pIoParameter);
    #endif
    
    // ǥХ֤Ԥʳξϥ꥽
    if (_iDevOpeStat != EIOVDEVIDLE)
        goto end;
    
    #ifdef _DEBUG
    printk("%s: pIoParameter->ulEraseWatchTime = %lu\n", PRN_DEV_NAME, pIoParameter->ulEraseWatchTime);
    #endif
    
    // ѥ᡼ꤵ줿õǧԤ(ms)ꥻõǧԤ(us)
    lEraseWatchTime = pIoParameter->ulEraseWatchTime * 1000;
    
    // õ̤ν
    pIoParameter->ulEraseResult = EIOVFLWRITEOK;
    
    // FLASH񤭹Ƭɥ쥹ΥåȡFPGAե졼ΰ裲
    pulFlashMemAddr = (unsigned long *)_pucPebRomAddr;
    
    // FLASHߵĥ쥸FLWå
    PebRegBitSet(REG_FL_Write, BIT_FLW);
    
    // ꥻåȥޥɽ񤭹
    PebRegPut(REG_FL_HAdr, MSK_FL_HAdr, 0);
    FlashMemPut(&pulFlashMemAddr[0x000], 0xf0);
    
    // ɥ쥹ʬʲν򷫤֤
    for (iPoint = 0; ulSectorAddr[iPoint] != (unsigned long)-1; iPoint ++)
    {
        // ߻μ
        do_gettimeofday(&tvNow);
        lEraseBaseTime = tvNow.tv_usec;
        
        // Хȥ⡼ɻǤΥ졼ޥɽ񤭹
        PebRegPut(REG_FL_HAdr, MSK_FL_HAdr, 0);
        FlashMemPut(&pulFlashMemAddr[0xaaa], 0xaa);                 // 1stХ饤ȥΥɥ쥹AAAhϢΥǡAAh
        FlashMemPut(&pulFlashMemAddr[0x555], 0x55);                 // 2ndХ饤ȥΥɥ쥹555hϢΥǡ55h
        FlashMemPut(&pulFlashMemAddr[0xaaa], 0x80);                 // 3rdХ饤ȥΥɥ쥹AAAhϢΥǡ80h
        
        // 졼оݤȤʤ륻ɥ쥹
        FlashMemPut(&pulFlashMemAddr[0xaaa], 0xaa);                 // 4thХ饤ȥΥɥ쥹AAAhϢΥǡAAh
        FlashMemPut(&pulFlashMemAddr[0x555], 0x55);                 // 5thХ饤ȥΥɥ쥹555hϢΥǡ55h
        PebRegPut(REG_FL_HAdr, MSK_FL_HAdr, ulSectorAddr[iPoint]);  // 6thХ饤ȥΥɥ쥹ϢΥǡ30h
        FlashMemPut(&pulFlashMemAddr[0x000], 0x30);                 // ɥ쥹ϥ쥸ͳ
        
        // FLASHߵĥ쥸򸵤˽񤭹߾֤Ѱܤå
        // FLBSY=0+BSYLAT=1äơ񤭹ߴλ
        // ʤѰܤʤȤθޡ򤫤ޤ
        while ((PebRegGet(REG_FL_Write, MSK_FL_Write) & (BIT_FLBSY | BIT_BSYLAT)) != BIT_BSYLAT)
        {
            // ߻μ
            do_gettimeofday(&tvNow);
            lEraseNowTime = tvNow.tv_usec;
            
            // ॢȥå
            if (lEraseNowTime < lEraseBaseTime)
                lEraseNowTime += 1000000;
            if ((lEraseNowTime - lEraseBaseTime) > lEraseWatchTime)
            {
                PebRegBitClr(REG_FL_Write, BIT_BSYLAT);
                pIoParameter->ulEraseResult = EIOVFLWRITETO;    // 񤭹ߥॢ
                goto skip;
            }
        }
        PebRegBitClr(REG_FL_Write, BIT_BSYLAT);
    }
    
skip:
    // FLASHߵĥ쥸FLWꥢ
    PebRegBitClr(REG_FL_Write, BIT_FLW);
    
    #ifdef _DEBUG
    printk("%s: pIoParameter->ulEraseResult = %lu\n", PRN_DEV_NAME, pIoParameter->ulEraseResult);
    #endif
    
    // ｪλ
    iResult = 0;
    
end:
    // λ
    #ifdef _DEBUG
    printk("%s: IoctlDelFlash: OUT(%d)\n", PRN_DEV_NAME, iResult);
    #endif
    return (iResult);
}


/****************************************************************************
 *
 *
 *  ؿ
 *
 *
 ****************************************************************************/

/*==========================================================================*
 *
 *  쥸꡼ɽ
 *
 *==========================================================================*
 *
 *εǽ
 *  쥸ޥͤ꡼ɤ롣
 *
 *η
 *  unsigned long PebRegGet(
 *      unsigned long ulPebRegAddr, // [I] 쥸륢ɥ쥹
 *      unsigned long ulPebRegMask  // [I] 쥸ޥ
 *  );
 *
 *͡
 *  쥸
 *
 *ա
 *  쥸ΰΥ륢ɥ쥹H'0000_0000-H'000F_FFFF
 *  쥸32bit
 *
 *==========================================================================*/
static unsigned long PebRegGet(unsigned long ulPebRegAddr, unsigned long ulPebRegMask)
{
    unsigned long *pulPebRegAddr, ulPebRegData;
    
    // 쥸ɥ쥹Ѵ
    pulPebRegAddr = (unsigned long *)(_pucPebRegAddr + (ulPebRegAddr & REG_PCI_MASK));
    
    // 쥸ͤΥ꡼
    ulPebRegData = *pulPebRegAddr;
    ulPebRegData &= ulPebRegMask;
    
    // λ
    #ifdef _DEBUGREG
    printk("%s: REG(%08lX) -> %08lX\n", PRN_DEV_NAME, ulPebRegAddr, ulPebRegData);
    #endif
    return (ulPebRegData);
}

/*==========================================================================*
 *
 *  쥸饤Ƚ
 *
 *==========================================================================*
 *
 *εǽ
 *  쥸إޥͤ饤Ȥ롣
 *
 *η
 *  void PebRegPut(
 *      unsigned long ulPebRegAddr, // [I] 쥸륢ɥ쥹
 *      unsigned long ulPebRegMask, // [I] 쥸ޥ
 *      unsigned long ulPebRegData  // [I] 쥸
 *  );
 *
 *͡
 *  ʤ
 *
 *ա
 *  쥸ΰΥ륢ɥ쥹H'0000_0000-H'000F_FFFF
 *  쥸32bit
 *
 *==========================================================================*/
static void PebRegPut(unsigned long ulPebRegAddr, unsigned long ulPebRegMask, unsigned long ulPebRegData)
{
    unsigned long *pulPebRegAddr;
    
    // ߡ꡼
    PebRegGet(ulPebRegAddr, ulPebRegMask);
    
    // 쥸ɥ쥹Ѵ
    pulPebRegAddr = (unsigned long *)(_pucPebRegAddr + (ulPebRegAddr & REG_PCI_MASK));
    
    // 쥸ͤΥ饤
    ulPebRegData &= ulPebRegMask;
    *pulPebRegAddr = ulPebRegData;
    
    // λ
    #ifdef _DEBUGREG
    printk("%s: %08lX -> REG(%08lX)\n", PRN_DEV_NAME, ulPebRegData, ulPebRegAddr);
    #endif
    return;
}

/*==========================================================================*
 *
 *  쥸ӥåȥåȽ
 *
 *==========================================================================*
 *
 *εǽ
 *  쥸ФƥӥåȥåȤԤ
 *
 *η
 *  void PebRegBitSet(
 *      unsigned long ulPebRegAddr, // [I] 쥸륢ɥ쥹
 *      unsigned long ulRegSetBit   // [I] 쥸åȥӥå
 *  );
 *
 *͡
 *  ʤ
 *
 *ա
 *  쥸ΰΥ륢ɥ쥹H'0000_0000-H'000F_FFFF
 *  쥸32bit
 *
 *==========================================================================*/
static void PebRegBitSet(unsigned long ulPebRegAddr, unsigned long ulRegSetBit)
{
    unsigned long *pulPebRegAddr, ulPebRegData;
    
    // 쥸ɥ쥹Ѵ
    pulPebRegAddr = (unsigned long *)(_pucPebRegAddr + (ulPebRegAddr & REG_PCI_MASK));
    
    // 쥸ͤΥӥåȥå
    ulPebRegData = *pulPebRegAddr;
    ulPebRegData |= ulRegSetBit;
    *pulPebRegAddr = ulPebRegData;
    
    // λ
    #ifdef _DEBUGREG
    printk("%s: %08lX -> REG(%08lX)\n", PRN_DEV_NAME, ulPebRegData, ulPebRegAddr);
    #endif
    return;
}

/*==========================================================================*
 *
 *  쥸ӥåȥꥢ
 *
 *==========================================================================*
 *
 *εǽ
 *  쥸ФƥӥåȥꥢԤ
 *
 *η
 *  void PebRegBitClr(
 *      unsigned long ulPebRegAddr, // [I] 쥸륢ɥ쥹
 *      unsigned long ulRegClrBit   // [I] 쥸ꥢӥå
 *  );
 *
 *͡
 *  ʤ
 *
 *ա
 *  쥸ΰΥ륢ɥ쥹H'0000_0000-H'000F_FFFF
 *  쥸32bit
 *
 *==========================================================================*/
static void PebRegBitClr(unsigned long ulPebRegAddr, unsigned long ulRegClrBit)
{
    unsigned long *pulPebRegAddr, ulPebRegData;
    
    // 쥸ɥ쥹Ѵ
    pulPebRegAddr = (unsigned long *)(_pucPebRegAddr + (ulPebRegAddr & REG_PCI_MASK));
    
    // 쥸ͤΥӥåȥꥢ
    ulPebRegData = *pulPebRegAddr;
    ulPebRegData &= ~ulRegClrBit;
    *pulPebRegAddr = ulPebRegData;
    
    // λ
    #ifdef _DEBUGREG
    printk("%s: %08lX -> REG(%08lX)\n", PRN_DEV_NAME, ulPebRegData, ulPebRegAddr);
    #endif
    return;
}

/*==========================================================================*
 *
 *  ꡼ɽ
 *
 *==========================================================================*
 *
 *εǽ
 *  ꤫ͤ꡼ɤ롣
 *
 *η
 *  unsigned long PebMemGet(
 *      unsigned long ulPebMemAddr  // [I] 륢ɥ쥹
 *  );
 *
 *͡
 *  
 *
 *ա
 *  ΰΥ륢ɥ쥹
 *  512MBξH'4000_0000-H'1FFF_FFFF
 *  1GBξˤH'4000_0000-H'3FFF_FFFF
 *  PCI١ɥ쥹ɥɥ쥹쥸ˤƥ١ɥ쥹
 *  ꥢ32bit
 *
 *==========================================================================*/
static unsigned long PebMemGet(unsigned long ulPebMemAddr)
{
    unsigned long *pulPebMemAddr, ulPebMemData;
    
    // PCI١ɥ쥹ɥɥ쥹쥸Υ饤
    PebRegPut(REG_PCIB_Adr, MSK_PCIB_Adr, ulPebMemAddr);
    
    // ꥢɥ쥹Ѵ
    pulPebMemAddr = (unsigned long *)(_pucPebRamAddr + (ulPebMemAddr & RAM_PCI_MASK));
    
    // ͤΥ꡼
    ulPebMemData = *pulPebMemAddr;
    
    // λ
    #ifdef _DEBUGMEM
    printk("%s: MEM(%08lX) -> %08lX\n", PRN_DEV_NAME, ulPebMemAddr, ulPebMemData);
    #endif
    return (ulPebMemData);
}

/*==========================================================================*
 *
 *  饤Ƚ
 *
 *==========================================================================*
 *
 *εǽ
 *  ͤ饤Ȥ롣
 *
 *η
 *  void PebMemPut(
 *      unsigned long ulPebMemAddr, // [I] 륢ɥ쥹
 *      unsigned long ulPebMemData  // [I] 
 *  );
 *
 *͡
 *  ʤ
 *
 *ա
 *  ΰΥ륢ɥ쥹
 *  512MBξH'4000_0000-H'1FFF_FFFF
 *  1GBξˤH'4000_0000-H'3FFF_FFFF
 *  PCI١ɥ쥹ɥɥ쥹쥸ˤƥ١ɥ쥹
 *  ꥢ32bit
 *
 *==========================================================================*/
static void PebMemPut(unsigned long ulPebMemAddr, unsigned long ulPebMemData)
{
    unsigned long *pulPebMemAddr;
    
    // PCI١ɥ쥹ɥɥ쥹쥸Υ饤
    PebRegPut(REG_PCIB_Adr, MSK_PCIB_Adr, ulPebMemAddr);
    
    // ꥢɥ쥹Ѵ
    pulPebMemAddr = (unsigned long *)(_pucPebRamAddr + (ulPebMemAddr & RAM_PCI_MASK));
    
    // ͤΥ饤
    *pulPebMemAddr = ulPebMemData;
    
    // λ
    #ifdef _DEBUGMEM
    printk("%s: %08lX -> MEM(%08lX)\n", PRN_DEV_NAME, ulPebMemData, ulPebMemAddr);
    #endif
    return;
}

/*==========================================================================*
 *
 *  եå꡼ɽ
 *
 *==========================================================================*
 *
 *εǽ
 *  Υեå꤫ͤ꡼ɤ롣
 *
 *η
 *  unsigned char FlashMemGet(
 *      unsigned long *pulFlashMemAddr  // [I] եå껲ȥݥ
 *  );
 *
 *͡
 *  
 *
 *ա
 *  ꥢ8bitPCIΤ32bit8bitѴ»
 *
 *==========================================================================*/
static unsigned char FlashMemGet(unsigned long *pulFlashMemAddr)
{
    unsigned long ulFlashMemData;
    
    // ͤΥ꡼
    ulFlashMemData = *pulFlashMemAddr;
    return ((unsigned char)ulFlashMemData);
}

/*==========================================================================*
 *
 *  եå饤Ƚ
 *
 *==========================================================================*
 *
 *εǽ
 *  Υեåͤ饤Ȥ롣
 *
 *η
 *  void FlashMemPut(
 *      unsigned long *pulFlashMemAddr, // [I] եå껲ȥݥ
 *      unsigned char ucFlashMemData    // [I] 
 *  );
 *
 *͡
 *  ʤ
 *
 *ա
 *  ꥢ8bitPCIΤ8bit32bitѴ»
 *
 *==========================================================================*/
static void FlashMemPut(unsigned long *pulFlashMemAddr, unsigned char ucFlashMemData)
{
    // ͤΥ饤
    *pulFlashMemAddr = (unsigned long)ucFlashMemData;
    return;
}

/*==========================================================================*
 *
 *  ǡХƥȽ
 *
 *==========================================================================*
 *
 *εǽ
 *  ΰƬ륢ɥ쥹Фơƥȥǡɤߤ
 *  פƤ뤳Ȥǧ롣
 *
 *η
 *  int DataBusTest(void);
 *
 *͡
 *  ｪλ    : 0
 *  ۾ｪλ    : -1
 *
 *ա
 *  DDR-DIMM64bitǡХΤᡢ32bitȲ32bitФƥƥȤ»
 *
 *==========================================================================*/
static int DataBusTest(void)
{
    int iResult = 0;
    static unsigned long ulTestAddr[] = {
        RAM_Font_Adr + 0x00000000, RAM_Font_Adr + 0x00000004, 
        (unsigned long)-1, 
    };
    static unsigned long ulTestData[] = {
        0x00000000, 
        0x00000001, 0x00000002, 0x00000004, 0x00000008, 
        0x00000010, 0x00000020, 0x00000040, 0x00000080, 
        0x00000100, 0x00000200, 0x00000400, 0x00000800, 
        0x00001000, 0x00002000, 0x00004000, 0x00008000, 
        0x00010000, 0x00020000, 0x00040000, 0x00080000, 
        0x00100000, 0x00200000, 0x00400000, 0x00800000, 
        0x01000000, 0x02000000, 0x04000000, 0x08000000, 
        0x10000000, 0x20000000, 0x40000000, 0x80000000, 
        (unsigned long)-1, 
    };
    int iPoint1, iPoint2;
    unsigned long ulReadData;
    
    // 
    #ifdef _DEBUG
    printk("%s: DataBusTest: IN()\n", PRN_DEV_NAME);
    #endif
    
    // ƥȥɥ쥹ʬʲν򷫤֤
    for (iPoint1 = 0; ulTestAddr[iPoint1] != (unsigned long)-1; iPoint1 ++)
    {
        // ƥȥǡʬʲν򷫤֤
        for (iPoint2 = 0; ulTestData[iPoint2] != (unsigned long)-1; iPoint2 ++)
        {
            // ƥȥɥ쥹˥ƥȥǡ饤
            PebMemPut(ulTestAddr[iPoint1], ulTestData[iPoint2]);
            
            // ƥȥɥ쥹ƥȥǡ꡼
            ulReadData = PebMemGet(ulTestAddr[iPoint1]);
            
            // ٥եå
            if (ulReadData != ulTestData[iPoint2])
            {
                // ٥ե顼
                printk("%s: data-bus fault.(addr: %08lX, write: %08lX, read: %08lX)\n", 
                    PRN_DEV_NAME, ulTestAddr[iPoint1], ulTestData[iPoint2], ulReadData);
                iResult = -1;
                goto end;
            }
        }
    }
    
end:
    // λ
    #ifdef _DEBUG
    printk("%s: DataBusTest: OUT(%d)\n", PRN_DEV_NAME, iResult);
    #endif
    return (iResult);
}

/*==========================================================================*
 *
 *  ɥ쥹ХƥȽ
 *
 *==========================================================================*
 *
 *εǽ
 *  ΰǤդΥ륢ɥ쥹Фơƥȥǡɤߤ
 *  פƤ뤳Ȥǧ롣
 *  θ塢ǤդΥ륢ɥ쥹ưƥƥȥǡߡ
 *  ʹߤΥ륢ɥ쥹˽߱ƶʤȤǧ롣
 *
 *η
 *  int AddrBusTest(void);
 *
 *͡
 *  ｪλ    : 0
 *  ۾ｪλ    : -1
 *
 *ա
 *  DDR-DIMM2ranksΤᡢȾȸȾФƥƥȤ»
 *
 *==========================================================================*/
static int AddrBusTest(void)
{
    int iResult = 0;
    static unsigned long ulTestAddr_512M_0[] = {
        RAM_Font_Adr + 0x00000000, 
        RAM_Font_Adr + 0x00000004, RAM_Font_Adr + 0x00000008, 
        RAM_Font_Adr + 0x00000010, RAM_Font_Adr + 0x00000020, RAM_Font_Adr + 0x00000040, RAM_Font_Adr + 0x00000080, 
        RAM_Font_Adr + 0x00000100, RAM_Font_Adr + 0x00000200, RAM_Font_Adr + 0x00000400, RAM_Font_Adr + 0x00000800, 
        RAM_Font_Adr + 0x00001000, RAM_Font_Adr + 0x00002000, RAM_Font_Adr + 0x00004000, RAM_Font_Adr + 0x00008000, 
        RAM_Font_Adr + 0x00010000, RAM_Font_Adr + 0x00020000, RAM_Font_Adr + 0x00040000, RAM_Font_Adr + 0x00080000, 
        RAM_Font_Adr + 0x00100000, RAM_Font_Adr + 0x00200000, RAM_Font_Adr + 0x00400000, RAM_Font_Adr + 0x00800000, 
        RAM_Font_Adr + 0x01000000, RAM_Font_Adr + 0x02000000, RAM_Font_Adr + 0x04000000, RAM_Font_Adr + 0x08000000, 
        (unsigned long)-1, 
    };
    static unsigned long ulTestAddr_512M_1[] = {
        RAM_Font_Adr + 0x10000000, 
        RAM_Font_Adr + 0x10000004, RAM_Font_Adr + 0x10000008, 
        RAM_Font_Adr + 0x10000010, RAM_Font_Adr + 0x10000020, RAM_Font_Adr + 0x10000040, RAM_Font_Adr + 0x10000080, 
        RAM_Font_Adr + 0x10000100, RAM_Font_Adr + 0x10000200, RAM_Font_Adr + 0x10000400, RAM_Font_Adr + 0x10000800, 
        RAM_Font_Adr + 0x10001000, RAM_Font_Adr + 0x10002000, RAM_Font_Adr + 0x10004000, RAM_Font_Adr + 0x10008000, 
        RAM_Font_Adr + 0x10010000, RAM_Font_Adr + 0x10020000, RAM_Font_Adr + 0x10040000, RAM_Font_Adr + 0x10080000, 
        RAM_Font_Adr + 0x10100000, RAM_Font_Adr + 0x10200000, RAM_Font_Adr + 0x10400000, RAM_Font_Adr + 0x10800000, 
        RAM_Font_Adr + 0x11000000, RAM_Font_Adr + 0x12000000, RAM_Font_Adr + 0x14000000, RAM_Font_Adr + 0x18000000, 
        (unsigned long)-1, 
    };
    static unsigned long ulTestAddr_1G_0[] = {
        RAM_Font_Adr + 0x00000000, 
        RAM_Font_Adr + 0x00000004, RAM_Font_Adr + 0x00000008, 
        RAM_Font_Adr + 0x00000010, RAM_Font_Adr + 0x00000020, RAM_Font_Adr + 0x00000040, RAM_Font_Adr + 0x00000080, 
        RAM_Font_Adr + 0x00000100, RAM_Font_Adr + 0x00000200, RAM_Font_Adr + 0x00000400, RAM_Font_Adr + 0x00000800, 
        RAM_Font_Adr + 0x00001000, RAM_Font_Adr + 0x00002000, RAM_Font_Adr + 0x00004000, RAM_Font_Adr + 0x00008000, 
        RAM_Font_Adr + 0x00010000, RAM_Font_Adr + 0x00020000, RAM_Font_Adr + 0x00040000, RAM_Font_Adr + 0x00080000, 
        RAM_Font_Adr + 0x00100000, RAM_Font_Adr + 0x00200000, RAM_Font_Adr + 0x00400000, RAM_Font_Adr + 0x00800000, 
        RAM_Font_Adr + 0x01000000, RAM_Font_Adr + 0x02000000, RAM_Font_Adr + 0x04000000, RAM_Font_Adr + 0x08000000, 
        RAM_Font_Adr + 0x10000000, 
        (unsigned long)-1, 
    };
    static unsigned long ulTestAddr_1G_1[] = {
        RAM_Font_Adr + 0x20000000, 
        RAM_Font_Adr + 0x20000004, RAM_Font_Adr + 0x20000008, 
        RAM_Font_Adr + 0x20000010, RAM_Font_Adr + 0x20000020, RAM_Font_Adr + 0x20000040, RAM_Font_Adr + 0x20000080, 
        RAM_Font_Adr + 0x20000100, RAM_Font_Adr + 0x20000200, RAM_Font_Adr + 0x20000400, RAM_Font_Adr + 0x20000800, 
        RAM_Font_Adr + 0x20001000, RAM_Font_Adr + 0x20002000, RAM_Font_Adr + 0x20004000, RAM_Font_Adr + 0x20008000, 
        RAM_Font_Adr + 0x20010000, RAM_Font_Adr + 0x20020000, RAM_Font_Adr + 0x20040000, RAM_Font_Adr + 0x20080000, 
        RAM_Font_Adr + 0x20100000, RAM_Font_Adr + 0x20200000, RAM_Font_Adr + 0x20400000, RAM_Font_Adr + 0x20800000, 
        RAM_Font_Adr + 0x21000000, RAM_Font_Adr + 0x22000000, RAM_Font_Adr + 0x24000000, RAM_Font_Adr + 0x28000000, 
        RAM_Font_Adr + 0x30000000, 
        (unsigned long)-1, 
    };
    static unsigned long *pulTestAddrList[2][2] = {
        { ulTestAddr_512M_0, ulTestAddr_1G_0, }, 
        { ulTestAddr_512M_1, ulTestAddr_1G_1, }, 
    };
    static unsigned long ulTestData1 = 0x55555555;
    static unsigned long ulTestData2 = 0xAAAAAAAA;
    unsigned long *pulTestAddr;
    int iPoint1, iPoint2, iPoint3;
    unsigned long ulReadData;
    
    // 
    #ifdef _DEBUG
    printk("%s: AddrBusTest: IN()\n", PRN_DEV_NAME);
    #endif
    
    // ȾȾʬʲν򷫤֤
    for (iPoint1 = 0; iPoint1 < 2; iPoint1 ++)
    {
        // Ѥƥȥɥ쥹
        pulTestAddr = pulTestAddrList[iPoint1][_uPebRamType];
        
        // ƥȥɥ쥹ʬʲν򷫤֤
        for (iPoint2 = 0; pulTestAddr[iPoint2] != (unsigned long)-1; iPoint2 ++)
        {
            // ƥȥɥ쥹˥ƥȥǡ饤
            PebMemPut(pulTestAddr[iPoint2], ulTestData1);
            
            // ƥȥɥ쥹ƥȥǡ꡼
            ulReadData = PebMemGet(pulTestAddr[iPoint2]);
            
            // ٥եå
            if (ulReadData != ulTestData1)
            {
                // ٥ե顼
                printk("%s: data-bus fault.(addr: %08lX, write: %08lX, read: %08lX)\n", 
                    PRN_DEV_NAME, pulTestAddr[iPoint2], ulTestData1, ulReadData);
                iResult = -1;
                goto end;
            }
        }
        
        // ƥȥɥ쥹ʬʲν򷫤֤
        for (iPoint2 = 0; pulTestAddr[iPoint2] != (unsigned long)-1; iPoint2 ++)
        {
            // ƥȥɥ쥹˥ƥȥǡ饤
            PebMemPut(pulTestAddr[iPoint2], ulTestData2);
            
            // ĤΥƥȥɥ쥹Фơʲν򷫤֤
            for (iPoint3 = iPoint2 + 1; pulTestAddr[iPoint3] != (unsigned long)-1; iPoint3 ++)
            {
                // ƥȥݥȤƥȥǡ꡼
                ulReadData = PebMemGet(pulTestAddr[iPoint3]);
                
                // ٥եå
                if (ulReadData != ulTestData1)
                {
                    // ٥ե顼
                    printk("%s: address-bus fault.(addr: %08lX)\n", PRN_DEV_NAME, pulTestAddr[iPoint3]);
                    iResult = -1;
                    goto end;
                }
            }
        }
    }
    
end:
    // λ
    #ifdef _DEBUG
    printk("%s: AddrBusTest: OUT(%d)\n", PRN_DEV_NAME, iResult);
    #endif
    return (iResult);
}

/*==========================================================================*
 *
 *  ꥳڥƥȽ
 *
 *==========================================================================*
 *
 *εǽ
 *  ΰǤդΥ륢ɥ쥹ϰϤФơƥȥǡɤߤ
 *  פƤ뤳Ȥǧ롣
 *
 *η
 *  int MemCompTest(void);
 *
 *͡
 *  ｪλ    : 0
 *  ۾ｪλ    : -1
 *
 *ա
 *  DDR-DIMM2ranksΤᡢȾȸȾƬ1MBϰϤФƥƥȤ»
 *
 *==========================================================================*/
static int MemCompTest(void)
{
    int iResult = 0;
    static unsigned long ulTestAddr_512M_0[] = {
        RAM_Font_Adr + 0x00000000, 
        (unsigned long)-1, 
    };
    static unsigned long ulTestAddr_512M_1[] = {
        RAM_Font_Adr + 0x10000000, 
        (unsigned long)-1, 
    };
    static unsigned long ulTestAddr_1G_0[] = {
        RAM_Font_Adr + 0x00000000, 
        (unsigned long)-1, 
    };
    static unsigned long ulTestAddr_1G_1[] = {
        RAM_Font_Adr + 0x20000000, 
        (unsigned long)-1, 
    };
    static unsigned long *pulTestAddrList[2][2] = {
        { ulTestAddr_512M_0, ulTestAddr_1G_0, }, 
        { ulTestAddr_512M_1, ulTestAddr_1G_1, }, 
    };
    static unsigned long ulTestRange = 1024 * 1024;
    static unsigned long ulTestData1 = 0x00000000;
    static unsigned long ulTestData2 = 0x55555555;
    static unsigned long ulTestData3 = 0xAAAAAAAA;
    static unsigned long ulTestData4 = 0xFFFFFFFF;
    unsigned long *pulTestAddr;
    int iPoint1, iPoint2;
    unsigned long ulRange;
    unsigned long ulReadData;
    unsigned long ulTestData5;
    
    // 
    #ifdef _DEBUG
    printk("%s: MemCompTest: IN()\n", PRN_DEV_NAME);
    #endif
    
    // ȾȾʬʲν򷫤֤
    for (iPoint1 = 0; iPoint1 < 2; iPoint1 ++)
    {
        // Ѥƥȥɥ쥹
        pulTestAddr = pulTestAddrList[iPoint1][_uPebRamType];
        
        // ƥȥɥ쥹ʬʲν򷫤֤
        for (iPoint2 = 0; pulTestAddr[iPoint2] != (unsigned long)-1; iPoint2 ++)
        {
            // ƥϰϤФơʲν򷫤֤
            for (ulRange = 0; ulRange < ulTestRange; ulRange += sizeof(unsigned long))
            {
                // ƥȥɥ쥹˥ƥȥǡ饤
                PebMemPut(pulTestAddr[iPoint2] + ulRange, ulTestData1);
                
                // ƥȥɥ쥹ƥȥǡ꡼
                ulReadData = PebMemGet(pulTestAddr[iPoint2] + ulRange);
                
                // ٥եå
                if (ulReadData != ulTestData1)
                {
                    // ٥ե顼
                    printk("%s: memory fault.(addr: %08lX, write: %08lX, read: %08lX)\n", 
                        PRN_DEV_NAME, pulTestAddr[iPoint2] + ulRange, ulTestData1, ulReadData);
                    iResult = -1;
                    goto end;
                }
            }
            
            // ƥϰϤФơʲν򷫤֤
            for (ulRange = 0; ulRange < ulTestRange; ulRange += sizeof(unsigned long))
            {
                // ƥȥɥ쥹˥ƥȥǡ饤
                PebMemPut(pulTestAddr[iPoint2] + ulRange, ulTestData2);
                
                // ƥȥɥ쥹ƥȥǡ꡼
                ulReadData = PebMemGet(pulTestAddr[iPoint2] + ulRange);
                
                // ٥եå
                if (ulReadData != ulTestData2)
                {
                    // ٥ե顼
                    printk("%s: memory fault.(addr: %08lX, write: %08lX, read: %08lX)\n", 
                        PRN_DEV_NAME, pulTestAddr[iPoint2] + ulRange, ulTestData2, ulReadData);
                    iResult = -1;
                    goto end;
                }
            }
            
            // ƥϰϤФơʲν򷫤֤
            for (ulRange = 0; ulRange < ulTestRange; ulRange += sizeof(unsigned long))
            {
                // ƥȥɥ쥹˥ƥȥǡ饤
                PebMemPut(pulTestAddr[iPoint2] + ulRange, ulTestData3);
                
                // ƥȥɥ쥹ƥȥǡ꡼
                ulReadData = PebMemGet(pulTestAddr[iPoint2] + ulRange);
                
                // ٥եå
                if (ulReadData != ulTestData3)
                {
                    // ٥ե顼
                    printk("%s: memory fault.(addr: %08lX, write: %08lX, read: %08lX)\n", 
                        PRN_DEV_NAME, pulTestAddr[iPoint2] + ulRange, ulTestData3, ulReadData);
                    iResult = -1;
                    goto end;
                }
            }
            
            // ƥϰϤФơʲν򷫤֤
            for (ulRange = 0; ulRange < ulTestRange; ulRange += sizeof(unsigned long))
            {
                // ƥȥɥ쥹˥ƥȥǡ饤
                PebMemPut(pulTestAddr[iPoint2] + ulRange, ulTestData4);
                
                // ƥȥɥ쥹ƥȥǡ꡼
                ulReadData = PebMemGet(pulTestAddr[iPoint2] + ulRange);
                
                // ٥եå
                if (ulReadData != ulTestData4)
                {
                    // ٥ե顼
                    printk("%s: memory fault.(addr: %08lX, write: %08lX, read: %08lX)\n", 
                        PRN_DEV_NAME, pulTestAddr[iPoint2] + ulRange, ulTestData4, ulReadData);
                    iResult = -1;
                    goto end;
                }
            }
            
            // ƥϰϤФơʲν򷫤֤
            for (ulRange = 0; ulRange < ulTestRange; ulRange += sizeof(unsigned long))
            {
                // ƥȥǡ󥯥ȥǡκ
                ulTestData5 = ((ulRange << 14) | (ulRange >> 2));
                
                // ƥȥɥ쥹˥ƥȥǡ饤
                PebMemPut(pulTestAddr[iPoint2] + ulRange, ulTestData5);
                
                // ƥȥɥ쥹ƥȥǡ꡼
                ulReadData = PebMemGet(pulTestAddr[iPoint2] + ulRange);
                
                // ٥եå
                if (ulReadData != ulTestData5)
                {
                    // ٥ե顼
                    printk("%s: memory fault.(addr: %08lX, write: %08lX, read: %08lX)\n", 
                        PRN_DEV_NAME, pulTestAddr[iPoint2] + ulRange, ulTestData5, ulReadData);
                    iResult = -1;
                    goto end;
                }
            }
        }
    }
    
end:
    // λ
    #ifdef _DEBUG
    printk("%s: MemCompTest: OUT(%d)\n", PRN_DEV_NAME, iResult);
    #endif
    return (iResult);
}

/*==========================================================================*
 *
 *  DMAڡ꡼ɽ
 *
 *==========================================================================*
 *
 *εǽ
 *  DMAڡХåեǡꥵʬǥХХåե˳Ǽ롣
 *
 *η
 *  unsigned int DmaPageRead(
 *      unsigned long ulDevBuffAddr,    // [I] ǥХХåեեåȥɥ쥹
 *      unsigned int uReadSize          // [I] ꡼ɥ
 *  );
 *
 *͡
 *  ¥꡼ɥ
 *
 *ա
 *  DMAڡ32bit
 *
 *==========================================================================*/
static unsigned int DmaPageRead(unsigned long ulDevBuffAddr, unsigned int uReadSize)
{
    unsigned int uSize;
    unsigned long *pulReadAddr, *pulWriteAddr;
    
    // 
    #ifdef _DEBUG
    printk("%s: DmaPageRead: IN(%08lX,%u)\n", PRN_DEV_NAME, ulDevBuffAddr, uReadSize);
    #endif
    
    // ǥХХåե꡼ɥ
    if ((ulDevBuffAddr + (unsigned long)uReadSize) > (unsigned long)_uDevBuffSize)
    {
        uReadSize = (unsigned int)((unsigned long)_uDevBuffSize - ulDevBuffAddr);
        if (ulDevBuffAddr >= (unsigned long)_uDevBuffSize)
            uReadSize = 0;
    }
    
    // ꡼ɥʬDMAڡХåեǡǥХХåե˳Ǽ
    pulReadAddr  = _pulDmaPageBuff;
    pulWriteAddr = (unsigned long *)(_pucDevDataBuff + ulDevBuffAddr);
    for (uSize = 0; uSize < uReadSize; uSize += sizeof(unsigned long))
        *pulWriteAddr ++ = *pulReadAddr ++;
    
    // ǥХХåեǡι
    _uDevDataLen = (unsigned int)(ulDevBuffAddr + (unsigned long)uSize);
    
    // λ
    #ifdef _DEBUG
    printk("%s: DmaPageRead: OUT(%u)\n", PRN_DEV_NAME, uSize);
    #endif
    return (uSize);
}

/*==========================================================================*
 *
 *  DMAڡ饤Ƚ
 *
 *==========================================================================*
 *
 *εǽ
 *  ǥХХåեǡꥵʬDMAڡХåե˳Ǽ롣
 *
 *η
 *  unsigned int DmaPageWrite(
 *      unsigned long ulDevBuffAddr,    // [I] ǥХХåեեåȥɥ쥹
 *      unsigned int uWriteSize         // [I] 饤ȥ
 *  );
 *
 *͡
 *  ¥饤ȥ
 *
 *ա
 *  DMAڡ32bit
 *
 *==========================================================================*/
static unsigned int DmaPageWrite(unsigned long ulDevBuffAddr, unsigned int uWriteSize)
{
    unsigned int uSize;
    unsigned long *pulReadAddr, *pulWriteAddr;
    
    // 
    #ifdef _DEBUG
    printk("%s: DmaPageWrite: IN(%08lX,%u)\n", PRN_DEV_NAME, ulDevBuffAddr, uWriteSize);
    #endif
    
    // ǥХХåեǡ饤ȥ
    if ((ulDevBuffAddr + (unsigned long)uWriteSize) > (unsigned long)_uDevDataLen)
    {
        uWriteSize = (unsigned int)((unsigned long)_uDevDataLen - ulDevBuffAddr);
        if (ulDevBuffAddr >= (unsigned long)_uDevDataLen)
            uWriteSize = 0;
    }
    
    // 饤ȥʬǥХХåեǡDMAڡХåե˳Ǽ
    pulReadAddr  = (unsigned long *)(_pucDevDataBuff + ulDevBuffAddr);
    pulWriteAddr = _pulDmaPageBuff;
    for (uSize = 0; uSize < uWriteSize; uSize += sizeof(unsigned long))
        *pulWriteAddr ++ = *pulReadAddr ++;
    
    // λ
    #ifdef _DEBUG
    printk("%s: DmaPageWrite: OUT(%u)\n", PRN_DEV_NAME, uSize);
    #endif
    return (uSize);
}
